/* puzzle-view.c generated by valac 0.44.0, the Vala compiler
 * generated from puzzle-view.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <librsvg/rsvg.h>
#include <gio/gio.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_PUZZLE_VIEW (puzzle_view_get_type ())
#define PUZZLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_VIEW, PuzzleView))
#define PUZZLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_VIEW, PuzzleViewClass))
#define IS_PUZZLE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_VIEW))
#define IS_PUZZLE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_VIEW))
#define PUZZLE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_VIEW, PuzzleViewClass))

typedef struct _PuzzleView PuzzleView;
typedef struct _PuzzleViewClass PuzzleViewClass;
typedef struct _PuzzleViewPrivate PuzzleViewPrivate;

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;
enum  {
	PUZZLE_VIEW_0_PROPERTY,
	PUZZLE_VIEW_PUZZLE_PROPERTY,
	PUZZLE_VIEW_NUM_PROPERTIES
};
static GParamSpec* puzzle_view_properties[PUZZLE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _PuzzlePrivate PuzzlePrivate;

struct _PuzzleView {
	GtkDrawingArea parent_instance;
	PuzzleViewPrivate * priv;
};

struct _PuzzleViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _PuzzleViewPrivate {
	gint render_size;
	gint piece_x;
	gint piece_y;
	gboolean piece_unmoved;
	gchar _piece_id;
	gchar last_piece_id;
	gdouble kx;
	gdouble ky;
	RsvgHandle* tiles_handle;
	GFile* image_file;
	cairo_surface_t* surface;
	Puzzle* _puzzle;
};

struct _Puzzle {
	GObject parent_instance;
	PuzzlePrivate * priv;
	gint width;
	gint height;
	gchar* map;
	gint map_length1;
	gchar* move_map;
	gint move_map_length1;
	gchar* orig_map;
	gint orig_map_length1;
	gchar* lastmove_map;
	gint lastmove_map_length1;
	gchar* undomove_map;
	gint undomove_map_length1;
	gint moves;
};

struct _PuzzleClass {
	GObjectClass parent_class;
};

static gint PuzzleView_private_offset;
static gpointer puzzle_view_parent_class = NULL;

GType puzzle_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleView, g_object_unref)
GType puzzle_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
#define PUZZLE_VIEW_SPACE_OFFSET 4
#define PUZZLE_VIEW_SPACE_PADDING 5
#define PUZZLE_VIEW_THEME_OVERLAY_SIZE 8
#define PUZZLE_VIEW_THEME_TILE_SEGMENTS 27
#define PUZZLE_VIEW_THEME_TILE_CENTER 14
#define PUZZLE_VIEW_THEME_TILE_SIZE 34
PuzzleView* puzzle_view_new (void);
PuzzleView* puzzle_view_construct (GType object_type);
static void puzzle_view_load_image (PuzzleView* self);
static gboolean puzzle_view_real_draw (GtkWidget* base,
                                cairo_t* cr);
static gint puzzle_view_get_tile_size (PuzzleView* self);
Puzzle* puzzle_view_get_puzzle (PuzzleView* self);
static void puzzle_view_draw_square (PuzzleView* self,
                              cairo_t* cr,
                              gint x,
                              gint y,
                              gdouble kx,
                              gdouble ky);
static gchar puzzle_view_get_piece_id (PuzzleView* self);
gchar puzzle_get_piece_id (Puzzle* self,
                           gchar* src,
                           gint src_length1,
                           gint x,
                           gint y);
gint puzzle_get_piece_nr (Puzzle* self,
                          gint x,
                          gint y);
static gboolean puzzle_view_real_button_press_event (GtkWidget* base,
                                              GdkEventButton* event);
gboolean puzzle_game_over (Puzzle* self);
static void puzzle_view_set_piece_id (PuzzleView* self,
                               gchar value);
static gchar* _vala_array_dup7 (gchar* self,
                         int length);
static gboolean puzzle_view_real_button_release_event (GtkWidget* base,
                                                GdkEventButton* event);
gboolean puzzle_movable (Puzzle* self,
                         gint id);
gboolean puzzle_mapcmp (Puzzle* self,
                        gchar* m1,
                        gint m1_length1,
                        gchar* m2,
                        gint m2_length1);
static gchar* _vala_array_dup8 (gchar* self,
                         int length);
static gchar* _vala_array_dup9 (gchar* self,
                         int length);
static gboolean puzzle_view_real_motion_notify_event (GtkWidget* base,
                                               GdkEventMotion* event);
gboolean puzzle_move_piece (Puzzle* self,
                            gchar id,
                            gint x1,
                            gint y1,
                            gint x2,
                            gint y2);
static void puzzle_view_puzzle_changed_cb (PuzzleView* self);
void puzzle_view_set_puzzle (PuzzleView* self,
                             Puzzle* value);
static void _puzzle_view_puzzle_changed_cb_puzzle_changed (Puzzle* _sender,
                                                    gpointer self);
static void puzzle_view_finalize (GObject * obj);
static void _vala_puzzle_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_puzzle_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
puzzle_view_get_instance_private (PuzzleView* self)
{
	return G_STRUCT_MEMBER_P (self, PuzzleView_private_offset);
}

PuzzleView*
puzzle_view_construct (GType object_type)
{
	PuzzleView * self = NULL;
#line 71 "../src/puzzle-view.vala"
	self = (PuzzleView*) g_object_new (object_type, NULL);
#line 73 "../src/puzzle-view.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 250, 250);
#line 74 "../src/puzzle-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) (((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_POINTER_MOTION_MASK) | GDK_BUTTON_RELEASE_MASK));
#line 75 "../src/puzzle-view.vala"
	puzzle_view_load_image (self);
#line 71 "../src/puzzle-view.vala"
	return self;
#line 204 "puzzle-view.c"
}

PuzzleView*
puzzle_view_new (void)
{
#line 71 "../src/puzzle-view.vala"
	return puzzle_view_construct (TYPE_PUZZLE_VIEW);
#line 212 "puzzle-view.c"
}

static void
puzzle_view_load_image (PuzzleView* self)
{
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 78 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/puzzle-view.vala"
	_tmp0_ = g_file_new_for_uri ("resource:///org/gnome/Klotski/ui/assets.svg");
#line 80 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->image_file);
#line 80 "../src/puzzle-view.vala"
	self->priv->image_file = _tmp0_;
#line 228 "puzzle-view.c"
	{
		RsvgHandle* _tmp1_ = NULL;
		GFile* _tmp2_;
		RsvgHandle* _tmp3_;
		RsvgHandle* _tmp4_;
#line 84 "../src/puzzle-view.vala"
		_tmp2_ = self->priv->image_file;
#line 84 "../src/puzzle-view.vala"
		_tmp3_ = rsvg_handle_new_from_gfile_sync (_tmp2_, RSVG_HANDLE_FLAGS_NONE, NULL, &_inner_error0_);
#line 84 "../src/puzzle-view.vala"
		_tmp1_ = _tmp3_;
#line 84 "../src/puzzle-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 242 "puzzle-view.c"
			goto __catch7_g_error;
		}
#line 84 "../src/puzzle-view.vala"
		_tmp4_ = _tmp1_;
#line 84 "../src/puzzle-view.vala"
		_tmp1_ = NULL;
#line 84 "../src/puzzle-view.vala"
		_g_object_unref0 (self->priv->tiles_handle);
#line 84 "../src/puzzle-view.vala"
		self->priv->tiles_handle = _tmp4_;
#line 82 "../src/puzzle-view.vala"
		_g_object_unref0 (_tmp1_);
#line 255 "puzzle-view.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 82 "../src/puzzle-view.vala"
		e = _inner_error0_;
#line 82 "../src/puzzle-view.vala"
		_inner_error0_ = NULL;
#line 95 "../src/puzzle-view.vala"
		_tmp5_ = stderr;
#line 95 "../src/puzzle-view.vala"
		_tmp6_ = e;
#line 95 "../src/puzzle-view.vala"
		_tmp7_ = _tmp6_->message;
#line 95 "../src/puzzle-view.vala"
		fprintf (_tmp5_, "%s %s\n", "Error in puzzle-view.vala load image:", _tmp7_);
#line 96 "../src/puzzle-view.vala"
		exit (EXIT_FAILURE);
#line 82 "../src/puzzle-view.vala"
		_g_error_free0 (e);
#line 280 "puzzle-view.c"
	}
	__finally7:
#line 82 "../src/puzzle-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "../src/puzzle-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "../src/puzzle-view.vala"
		g_clear_error (&_inner_error0_);
#line 82 "../src/puzzle-view.vala"
		return;
#line 291 "puzzle-view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 123 "../src/puzzle-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 300 "puzzle-view.c"
}

static gboolean
puzzle_view_real_draw (GtkWidget* base,
                       cairo_t* cr)
{
	PuzzleView * self;
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp16_;
	GtkStyleContext* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkStyleContext* _tmp19_;
	GdkRGBA fg = {0};
	GtkStyleContext* _tmp20_;
	GdkRGBA _tmp21_ = {0};
	GdkRGBA bg = {0};
	GtkStyleContext* _tmp22_;
	GdkRGBA _tmp23_ = {0};
	GtkStyleContext* _tmp24_;
	GdkRGBA _tmp25_;
	gint width = 0;
	gint height = 0;
	GdkRGBA _tmp26_;
	gdouble kwidth = 0.0;
	Puzzle* _tmp27_;
	Puzzle* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gdouble kheight = 0.0;
	Puzzle* _tmp31_;
	Puzzle* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
#line 100 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 100 "../src/puzzle-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 102 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_tile_size (self);
#line 102 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 102 "../src/puzzle-view.vala"
	if (_tmp1_ != self->priv->render_size) {
#line 347 "puzzle-view.c"
		RsvgHandle* _tmp2_;
		gint _tmp14_;
		gint _tmp15_;
#line 104 "../src/puzzle-view.vala"
		_tmp2_ = self->priv->tiles_handle;
#line 104 "../src/puzzle-view.vala"
		if (_tmp2_ != NULL) {
#line 355 "puzzle-view.c"
			gint height = 0;
			gint _tmp3_;
			gint _tmp4_;
			gint width = 0;
			gint _tmp5_;
			gint _tmp6_;
			cairo_surface_t* _tmp7_;
			cairo_surface_t* _tmp8_;
			cairo_t* c = NULL;
			cairo_surface_t* _tmp9_;
			cairo_t* _tmp10_;
			gdouble sfw = 0.0;
			gdouble sfh = 0.0;
			cairo_t* _tmp11_;
			RsvgHandle* _tmp12_;
			cairo_t* _tmp13_;
#line 106 "../src/puzzle-view.vala"
			_tmp3_ = puzzle_view_get_tile_size (self);
#line 106 "../src/puzzle-view.vala"
			_tmp4_ = _tmp3_;
#line 106 "../src/puzzle-view.vala"
			height = _tmp4_ * 2;
#line 107 "../src/puzzle-view.vala"
			_tmp5_ = puzzle_view_get_tile_size (self);
#line 107 "../src/puzzle-view.vala"
			_tmp6_ = _tmp5_;
#line 107 "../src/puzzle-view.vala"
			width = _tmp6_ * PUZZLE_VIEW_THEME_TILE_SEGMENTS;
#line 109 "../src/puzzle-view.vala"
			_tmp7_ = cairo_get_target (cr);
#line 109 "../src/puzzle-view.vala"
			_tmp8_ = cairo_surface_create_similar (_tmp7_, CAIRO_CONTENT_COLOR_ALPHA, width, height);
#line 109 "../src/puzzle-view.vala"
			_cairo_surface_destroy0 (self->priv->surface);
#line 109 "../src/puzzle-view.vala"
			self->priv->surface = _tmp8_;
#line 110 "../src/puzzle-view.vala"
			_tmp9_ = self->priv->surface;
#line 110 "../src/puzzle-view.vala"
			_tmp10_ = cairo_create (_tmp9_);
#line 110 "../src/puzzle-view.vala"
			c = _tmp10_;
#line 113 "../src/puzzle-view.vala"
			sfw = ((gdouble) width) / 918;
#line 114 "../src/puzzle-view.vala"
			sfh = ((gdouble) height) / 68;
#line 116 "../src/puzzle-view.vala"
			_tmp11_ = c;
#line 116 "../src/puzzle-view.vala"
			cairo_scale (_tmp11_, sfw, sfh);
#line 118 "../src/puzzle-view.vala"
			_tmp12_ = self->priv->tiles_handle;
#line 118 "../src/puzzle-view.vala"
			_tmp13_ = c;
#line 118 "../src/puzzle-view.vala"
			rsvg_handle_render_cairo (_tmp12_, _tmp13_);
#line 104 "../src/puzzle-view.vala"
			_cairo_destroy0 (c);
#line 414 "puzzle-view.c"
		}
#line 120 "../src/puzzle-view.vala"
		_tmp14_ = puzzle_view_get_tile_size (self);
#line 120 "../src/puzzle-view.vala"
		_tmp15_ = _tmp14_;
#line 120 "../src/puzzle-view.vala"
		self->priv->render_size = _tmp15_;
#line 422 "puzzle-view.c"
	}
#line 123 "../src/puzzle-view.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 123 "../src/puzzle-view.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 123 "../src/puzzle-view.vala"
	style = _tmp17_;
#line 124 "../src/puzzle-view.vala"
	_tmp18_ = style;
#line 124 "../src/puzzle-view.vala"
	gtk_style_context_save (_tmp18_);
#line 125 "../src/puzzle-view.vala"
	_tmp19_ = style;
#line 125 "../src/puzzle-view.vala"
	gtk_style_context_set_state (_tmp19_, GTK_STATE_FLAG_NORMAL);
#line 126 "../src/puzzle-view.vala"
	_tmp20_ = style;
#line 126 "../src/puzzle-view.vala"
	gtk_style_context_get_color (_tmp20_, GTK_STATE_FLAG_NORMAL, &_tmp21_);
#line 126 "../src/puzzle-view.vala"
	fg = _tmp21_;
#line 127 "../src/puzzle-view.vala"
	_tmp22_ = style;
#line 127 "../src/puzzle-view.vala"
	gtk_style_context_get_background_color (_tmp22_, GTK_STATE_FLAG_NORMAL, &_tmp23_);
#line 127 "../src/puzzle-view.vala"
	bg = _tmp23_;
#line 128 "../src/puzzle-view.vala"
	_tmp24_ = style;
#line 128 "../src/puzzle-view.vala"
	gtk_style_context_restore (_tmp24_);
#line 130 "../src/puzzle-view.vala"
	_tmp25_ = bg;
#line 130 "../src/puzzle-view.vala"
	gdk_cairo_set_source_rgba (cr, &_tmp25_);
#line 131 "../src/puzzle-view.vala"
	cairo_paint (cr);
#line 133 "../src/puzzle-view.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 134 "../src/puzzle-view.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 136 "../src/puzzle-view.vala"
	_tmp26_ = fg;
#line 136 "../src/puzzle-view.vala"
	gdk_cairo_set_source_rgba (cr, &_tmp26_);
#line 137 "../src/puzzle-view.vala"
	cairo_set_line_width (cr, 1.0);
#line 139 "../src/puzzle-view.vala"
	_tmp27_ = puzzle_view_get_puzzle (self);
#line 139 "../src/puzzle-view.vala"
	_tmp28_ = _tmp27_;
#line 139 "../src/puzzle-view.vala"
	_tmp29_ = puzzle_view_get_tile_size (self);
#line 139 "../src/puzzle-view.vala"
	_tmp30_ = _tmp29_;
#line 139 "../src/puzzle-view.vala"
	kwidth = ((_tmp28_->width * _tmp30_) + PUZZLE_VIEW_SPACE_PADDING) - 2.0;
#line 140 "../src/puzzle-view.vala"
	_tmp31_ = puzzle_view_get_puzzle (self);
#line 140 "../src/puzzle-view.vala"
	_tmp32_ = _tmp31_;
#line 140 "../src/puzzle-view.vala"
	_tmp33_ = puzzle_view_get_tile_size (self);
#line 140 "../src/puzzle-view.vala"
	_tmp34_ = _tmp33_;
#line 140 "../src/puzzle-view.vala"
	kheight = ((_tmp32_->height * _tmp34_) + PUZZLE_VIEW_SPACE_PADDING) - 2.0;
#line 141 "../src/puzzle-view.vala"
	self->priv->kx = (width - kwidth) / 2.0;
#line 142 "../src/puzzle-view.vala"
	self->priv->ky = (height - kheight) / 2.0;
#line 144 "../src/puzzle-view.vala"
	cairo_rectangle (cr, self->priv->kx, self->priv->ky, kwidth, kheight);
#line 145 "../src/puzzle-view.vala"
	cairo_stroke (cr);
#line 498 "puzzle-view.c"
	{
		gint y = 0;
#line 147 "../src/puzzle-view.vala"
		y = 0;
#line 503 "puzzle-view.c"
		{
			gboolean _tmp35_ = FALSE;
#line 147 "../src/puzzle-view.vala"
			_tmp35_ = TRUE;
#line 147 "../src/puzzle-view.vala"
			while (TRUE) {
#line 510 "puzzle-view.c"
				Puzzle* _tmp37_;
				Puzzle* _tmp38_;
#line 147 "../src/puzzle-view.vala"
				if (!_tmp35_) {
#line 515 "puzzle-view.c"
					gint _tmp36_;
#line 147 "../src/puzzle-view.vala"
					_tmp36_ = y;
#line 147 "../src/puzzle-view.vala"
					y = _tmp36_ + 1;
#line 521 "puzzle-view.c"
				}
#line 147 "../src/puzzle-view.vala"
				_tmp35_ = FALSE;
#line 147 "../src/puzzle-view.vala"
				_tmp37_ = puzzle_view_get_puzzle (self);
#line 147 "../src/puzzle-view.vala"
				_tmp38_ = _tmp37_;
#line 147 "../src/puzzle-view.vala"
				if (!(y < _tmp38_->height)) {
#line 147 "../src/puzzle-view.vala"
					break;
#line 533 "puzzle-view.c"
				}
				{
					gint x = 0;
#line 148 "../src/puzzle-view.vala"
					x = 0;
#line 539 "puzzle-view.c"
					{
						gboolean _tmp39_ = FALSE;
#line 148 "../src/puzzle-view.vala"
						_tmp39_ = TRUE;
#line 148 "../src/puzzle-view.vala"
						while (TRUE) {
#line 546 "puzzle-view.c"
							Puzzle* _tmp41_;
							Puzzle* _tmp42_;
							gchar _tmp43_;
							gchar _tmp44_;
							Puzzle* _tmp45_;
							Puzzle* _tmp46_;
							Puzzle* _tmp47_;
							Puzzle* _tmp48_;
							gchar* _tmp49_;
							gint _tmp49__length1;
#line 148 "../src/puzzle-view.vala"
							if (!_tmp39_) {
#line 559 "puzzle-view.c"
								gint _tmp40_;
#line 148 "../src/puzzle-view.vala"
								_tmp40_ = x;
#line 148 "../src/puzzle-view.vala"
								x = _tmp40_ + 1;
#line 565 "puzzle-view.c"
							}
#line 148 "../src/puzzle-view.vala"
							_tmp39_ = FALSE;
#line 148 "../src/puzzle-view.vala"
							_tmp41_ = puzzle_view_get_puzzle (self);
#line 148 "../src/puzzle-view.vala"
							_tmp42_ = _tmp41_;
#line 148 "../src/puzzle-view.vala"
							if (!(x < _tmp42_->width)) {
#line 148 "../src/puzzle-view.vala"
								break;
#line 577 "puzzle-view.c"
							}
#line 150 "../src/puzzle-view.vala"
							puzzle_view_draw_square (self, cr, x, y, self->priv->kx, self->priv->ky);
#line 152 "../src/puzzle-view.vala"
							_tmp43_ = puzzle_view_get_piece_id (self);
#line 152 "../src/puzzle-view.vala"
							_tmp44_ = _tmp43_;
#line 152 "../src/puzzle-view.vala"
							_tmp45_ = puzzle_view_get_puzzle (self);
#line 152 "../src/puzzle-view.vala"
							_tmp46_ = _tmp45_;
#line 152 "../src/puzzle-view.vala"
							_tmp47_ = puzzle_view_get_puzzle (self);
#line 152 "../src/puzzle-view.vala"
							_tmp48_ = _tmp47_;
#line 152 "../src/puzzle-view.vala"
							_tmp49_ = _tmp48_->map;
#line 152 "../src/puzzle-view.vala"
							_tmp49__length1 = _tmp48_->map_length1;
#line 152 "../src/puzzle-view.vala"
							if (_tmp44_ == puzzle_get_piece_id (_tmp46_, _tmp49_, (gint) _tmp49__length1, x, y)) {
#line 599 "puzzle-view.c"
								GdkRGBA _tmp50_ = {0};
								gint _tmp51_;
								gint _tmp52_;
								gint _tmp53_;
								gint _tmp54_;
								gint _tmp55_;
								gint _tmp56_;
								gint _tmp57_;
								gint _tmp58_;
#line 154 "../src/puzzle-view.vala"
								_tmp50_.red = 1.0;
#line 154 "../src/puzzle-view.vala"
								_tmp50_.green = 1.0;
#line 154 "../src/puzzle-view.vala"
								_tmp50_.blue = 1.0;
#line 154 "../src/puzzle-view.vala"
								_tmp50_.alpha = 0.2;
#line 154 "../src/puzzle-view.vala"
								gdk_cairo_set_source_rgba (cr, &_tmp50_);
#line 155 "../src/puzzle-view.vala"
								_tmp51_ = puzzle_view_get_tile_size (self);
#line 155 "../src/puzzle-view.vala"
								_tmp52_ = _tmp51_;
#line 155 "../src/puzzle-view.vala"
								_tmp53_ = puzzle_view_get_tile_size (self);
#line 155 "../src/puzzle-view.vala"
								_tmp54_ = _tmp53_;
#line 155 "../src/puzzle-view.vala"
								_tmp55_ = puzzle_view_get_tile_size (self);
#line 155 "../src/puzzle-view.vala"
								_tmp56_ = _tmp55_;
#line 155 "../src/puzzle-view.vala"
								_tmp57_ = puzzle_view_get_tile_size (self);
#line 155 "../src/puzzle-view.vala"
								_tmp58_ = _tmp57_;
#line 155 "../src/puzzle-view.vala"
								cairo_rectangle (cr, (x * _tmp52_) + self->priv->kx, (y * _tmp54_) + self->priv->ky, (gdouble) _tmp56_, (gdouble) _tmp58_);
#line 156 "../src/puzzle-view.vala"
								cairo_fill (cr);
#line 639 "puzzle-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 160 "../src/puzzle-view.vala"
	result = FALSE;
#line 160 "../src/puzzle-view.vala"
	_g_object_unref0 (style);
#line 160 "../src/puzzle-view.vala"
	return result;
#line 653 "puzzle-view.c"
}

static void
puzzle_view_draw_square (PuzzleView* self,
                         cairo_t* cr,
                         gint x,
                         gint y,
                         gdouble kx,
                         gdouble ky)
{
	GdkRectangle rect = {0};
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkStyleContext* _tmp11_;
	GdkRGBA bg = {0};
	GtkStyleContext* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	GtkStyleContext* _tmp14_;
	GdkRectangle _tmp15_;
	GdkRGBA _tmp16_;
	Puzzle* _tmp17_;
	Puzzle* _tmp18_;
	Puzzle* _tmp19_;
	Puzzle* _tmp20_;
	gchar* _tmp21_;
	gint _tmp21__length1;
	Puzzle* _tmp32_;
	Puzzle* _tmp33_;
	Puzzle* _tmp34_;
	Puzzle* _tmp35_;
	gchar* _tmp36_;
	gint _tmp36__length1;
#line 163 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/puzzle-view.vala"
	g_return_if_fail (cr != NULL);
#line 165 "../src/puzzle-view.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 166 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_tile_size (self);
#line 166 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 166 "../src/puzzle-view.vala"
	rect.x = (((x * _tmp1_) + PUZZLE_VIEW_SPACE_OFFSET) + ((gint) kx)) - 1;
#line 167 "../src/puzzle-view.vala"
	_tmp2_ = puzzle_view_get_tile_size (self);
#line 167 "../src/puzzle-view.vala"
	_tmp3_ = _tmp2_;
#line 167 "../src/puzzle-view.vala"
	rect.y = (((y * _tmp3_) + PUZZLE_VIEW_SPACE_OFFSET) + ((gint) ky)) - 1;
#line 168 "../src/puzzle-view.vala"
	_tmp4_ = puzzle_view_get_tile_size (self);
#line 168 "../src/puzzle-view.vala"
	_tmp5_ = _tmp4_;
#line 168 "../src/puzzle-view.vala"
	rect.width = _tmp5_;
#line 169 "../src/puzzle-view.vala"
	_tmp6_ = puzzle_view_get_tile_size (self);
#line 169 "../src/puzzle-view.vala"
	_tmp7_ = _tmp6_;
#line 169 "../src/puzzle-view.vala"
	rect.height = _tmp7_;
#line 171 "../src/puzzle-view.vala"
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 171 "../src/puzzle-view.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 171 "../src/puzzle-view.vala"
	style = _tmp9_;
#line 172 "../src/puzzle-view.vala"
	_tmp10_ = style;
#line 172 "../src/puzzle-view.vala"
	gtk_style_context_save (_tmp10_);
#line 173 "../src/puzzle-view.vala"
	_tmp11_ = style;
#line 173 "../src/puzzle-view.vala"
	gtk_style_context_set_state (_tmp11_, GTK_STATE_FLAG_NORMAL);
#line 174 "../src/puzzle-view.vala"
	_tmp12_ = style;
#line 174 "../src/puzzle-view.vala"
	gtk_style_context_get_background_color (_tmp12_, GTK_STATE_FLAG_NORMAL, &_tmp13_);
#line 174 "../src/puzzle-view.vala"
	bg = _tmp13_;
#line 175 "../src/puzzle-view.vala"
	_tmp14_ = style;
#line 175 "../src/puzzle-view.vala"
	gtk_style_context_restore (_tmp14_);
#line 177 "../src/puzzle-view.vala"
	_tmp15_ = rect;
#line 177 "../src/puzzle-view.vala"
	gdk_cairo_rectangle (cr, &_tmp15_);
#line 178 "../src/puzzle-view.vala"
	_tmp16_ = bg;
#line 178 "../src/puzzle-view.vala"
	gdk_cairo_set_source_rgba (cr, &_tmp16_);
#line 180 "../src/puzzle-view.vala"
	cairo_fill (cr);
#line 182 "../src/puzzle-view.vala"
	_tmp17_ = puzzle_view_get_puzzle (self);
#line 182 "../src/puzzle-view.vala"
	_tmp18_ = _tmp17_;
#line 182 "../src/puzzle-view.vala"
	_tmp19_ = puzzle_view_get_puzzle (self);
#line 182 "../src/puzzle-view.vala"
	_tmp20_ = _tmp19_;
#line 182 "../src/puzzle-view.vala"
	_tmp21_ = _tmp20_->map;
#line 182 "../src/puzzle-view.vala"
	_tmp21__length1 = _tmp20_->map_length1;
#line 182 "../src/puzzle-view.vala"
	if (puzzle_get_piece_id (_tmp18_, _tmp21_, (gint) _tmp21__length1, x, y) != ' ') {
#line 774 "puzzle-view.c"
		GdkRectangle _tmp22_;
		cairo_surface_t* _tmp23_;
		GdkRectangle _tmp24_;
		Puzzle* _tmp25_;
		Puzzle* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		GdkRectangle _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
#line 184 "../src/puzzle-view.vala"
		_tmp22_ = rect;
#line 184 "../src/puzzle-view.vala"
		gdk_cairo_rectangle (cr, &_tmp22_);
#line 185 "../src/puzzle-view.vala"
		_tmp23_ = self->priv->surface;
#line 185 "../src/puzzle-view.vala"
		_tmp24_ = rect;
#line 185 "../src/puzzle-view.vala"
		_tmp25_ = puzzle_view_get_puzzle (self);
#line 185 "../src/puzzle-view.vala"
		_tmp26_ = _tmp25_;
#line 185 "../src/puzzle-view.vala"
		_tmp27_ = puzzle_view_get_tile_size (self);
#line 185 "../src/puzzle-view.vala"
		_tmp28_ = _tmp27_;
#line 185 "../src/puzzle-view.vala"
		_tmp29_ = rect;
#line 185 "../src/puzzle-view.vala"
		_tmp30_ = puzzle_view_get_tile_size (self);
#line 185 "../src/puzzle-view.vala"
		_tmp31_ = _tmp30_;
#line 185 "../src/puzzle-view.vala"
		cairo_set_source_surface (cr, _tmp23_, (gdouble) (_tmp24_.x - (puzzle_get_piece_nr (_tmp26_, x, y) * _tmp28_)), (gdouble) (_tmp29_.y - (_tmp31_ / 2)));
#line 186 "../src/puzzle-view.vala"
		cairo_fill (cr);
#line 811 "puzzle-view.c"
	}
#line 189 "../src/puzzle-view.vala"
	_tmp32_ = puzzle_view_get_puzzle (self);
#line 189 "../src/puzzle-view.vala"
	_tmp33_ = _tmp32_;
#line 189 "../src/puzzle-view.vala"
	_tmp34_ = puzzle_view_get_puzzle (self);
#line 189 "../src/puzzle-view.vala"
	_tmp35_ = _tmp34_;
#line 189 "../src/puzzle-view.vala"
	_tmp36_ = _tmp35_->map;
#line 189 "../src/puzzle-view.vala"
	_tmp36__length1 = _tmp35_->map_length1;
#line 189 "../src/puzzle-view.vala"
	if (puzzle_get_piece_id (_tmp33_, _tmp36_, (gint) _tmp36__length1, x, y) == '*') {
#line 827 "puzzle-view.c"
		gint value = 0;
		Puzzle* _tmp37_;
		Puzzle* _tmp38_;
		Puzzle* _tmp39_;
		Puzzle* _tmp40_;
		gchar* _tmp41_;
		gint _tmp41__length1;
		gint overlay_size = 0;
		gint _tmp42_;
		gint _tmp43_;
		gint overlay_offset = 0;
		gint _tmp44_;
		gint _tmp45_;
		GdkRectangle _tmp46_;
		GdkRectangle _tmp47_;
		cairo_surface_t* _tmp48_;
		GdkRectangle _tmp49_;
		gint _tmp50_;
		gint _tmp51_;
		GdkRectangle _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
#line 191 "../src/puzzle-view.vala"
		value = 22;
#line 192 "../src/puzzle-view.vala"
		_tmp37_ = puzzle_view_get_puzzle (self);
#line 192 "../src/puzzle-view.vala"
		_tmp38_ = _tmp37_;
#line 192 "../src/puzzle-view.vala"
		_tmp39_ = puzzle_view_get_puzzle (self);
#line 192 "../src/puzzle-view.vala"
		_tmp40_ = _tmp39_;
#line 192 "../src/puzzle-view.vala"
		_tmp41_ = _tmp40_->orig_map;
#line 192 "../src/puzzle-view.vala"
		_tmp41__length1 = _tmp40_->orig_map_length1;
#line 192 "../src/puzzle-view.vala"
		if (puzzle_get_piece_id (_tmp38_, _tmp41_, (gint) _tmp41__length1, x, y) == '.') {
#line 193 "../src/puzzle-view.vala"
			value = 20;
#line 868 "puzzle-view.c"
		}
#line 195 "../src/puzzle-view.vala"
		_tmp42_ = puzzle_view_get_tile_size (self);
#line 195 "../src/puzzle-view.vala"
		_tmp43_ = _tmp42_;
#line 195 "../src/puzzle-view.vala"
		overlay_size = (PUZZLE_VIEW_THEME_OVERLAY_SIZE * _tmp43_) / PUZZLE_VIEW_THEME_TILE_SIZE;
#line 196 "../src/puzzle-view.vala"
		_tmp44_ = puzzle_view_get_tile_size (self);
#line 196 "../src/puzzle-view.vala"
		_tmp45_ = _tmp44_;
#line 196 "../src/puzzle-view.vala"
		overlay_offset = ((PUZZLE_VIEW_THEME_TILE_CENTER * _tmp45_) / PUZZLE_VIEW_THEME_TILE_SIZE) - (overlay_size / 2);
#line 198 "../src/puzzle-view.vala"
		_tmp46_ = rect;
#line 198 "../src/puzzle-view.vala"
		_tmp47_ = rect;
#line 198 "../src/puzzle-view.vala"
		cairo_rectangle (cr, (gdouble) (_tmp46_.x + overlay_offset), (gdouble) (_tmp47_.y + overlay_offset), (gdouble) overlay_size, (gdouble) overlay_size);
#line 201 "../src/puzzle-view.vala"
		_tmp48_ = self->priv->surface;
#line 201 "../src/puzzle-view.vala"
		_tmp49_ = rect;
#line 201 "../src/puzzle-view.vala"
		_tmp50_ = puzzle_view_get_tile_size (self);
#line 201 "../src/puzzle-view.vala"
		_tmp51_ = _tmp50_;
#line 201 "../src/puzzle-view.vala"
		_tmp52_ = rect;
#line 201 "../src/puzzle-view.vala"
		_tmp53_ = puzzle_view_get_tile_size (self);
#line 201 "../src/puzzle-view.vala"
		_tmp54_ = _tmp53_;
#line 201 "../src/puzzle-view.vala"
		cairo_set_source_surface (cr, _tmp48_, (gdouble) (_tmp49_.x - (value * _tmp51_)), (gdouble) (_tmp52_.y - (_tmp54_ / 2)));
#line 202 "../src/puzzle-view.vala"
		cairo_fill (cr);
#line 906 "puzzle-view.c"
	}
#line 163 "../src/puzzle-view.vala"
	_g_object_unref0 (style);
#line 910 "puzzle-view.c"
}

static gchar*
_vala_array_dup7 (gchar* self,
                  int length)
{
#line 228 "../src/puzzle-view.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 919 "puzzle-view.c"
}

static gboolean
puzzle_view_real_button_press_event (GtkWidget* base,
                                     GdkEventButton* event)
{
	PuzzleView * self;
	gboolean result = FALSE;
#line 206 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 206 "../src/puzzle-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 208 "../src/puzzle-view.vala"
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 934 "puzzle-view.c"
		Puzzle* _tmp0_;
		Puzzle* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar new_piece_id = '\0';
		Puzzle* _tmp6_;
		Puzzle* _tmp7_;
		Puzzle* _tmp8_;
		Puzzle* _tmp9_;
		gchar* _tmp10_;
		gint _tmp10__length1;
		gboolean _tmp11_ = FALSE;
		gchar _tmp12_;
		gchar _tmp13_;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		Puzzle* _tmp20_;
		Puzzle* _tmp21_;
		Puzzle* _tmp22_;
		Puzzle* _tmp23_;
		gchar* _tmp24_;
		gint _tmp24__length1;
		gchar* _tmp25_;
		gint _tmp25__length1;
#line 210 "../src/puzzle-view.vala"
		_tmp0_ = puzzle_view_get_puzzle (self);
#line 210 "../src/puzzle-view.vala"
		_tmp1_ = _tmp0_;
#line 210 "../src/puzzle-view.vala"
		if (puzzle_game_over (_tmp1_)) {
#line 211 "../src/puzzle-view.vala"
			result = FALSE;
#line 211 "../src/puzzle-view.vala"
			return result;
#line 973 "puzzle-view.c"
		}
#line 213 "../src/puzzle-view.vala"
		_tmp2_ = puzzle_view_get_tile_size (self);
#line 213 "../src/puzzle-view.vala"
		_tmp3_ = _tmp2_;
#line 213 "../src/puzzle-view.vala"
		self->priv->piece_x = ((gint) (event->x - self->priv->kx)) / _tmp3_;
#line 214 "../src/puzzle-view.vala"
		_tmp4_ = puzzle_view_get_tile_size (self);
#line 214 "../src/puzzle-view.vala"
		_tmp5_ = _tmp4_;
#line 214 "../src/puzzle-view.vala"
		self->priv->piece_y = ((gint) (event->y - self->priv->ky)) / _tmp5_;
#line 215 "../src/puzzle-view.vala"
		_tmp6_ = puzzle_view_get_puzzle (self);
#line 215 "../src/puzzle-view.vala"
		_tmp7_ = _tmp6_;
#line 215 "../src/puzzle-view.vala"
		_tmp8_ = puzzle_view_get_puzzle (self);
#line 215 "../src/puzzle-view.vala"
		_tmp9_ = _tmp8_;
#line 215 "../src/puzzle-view.vala"
		_tmp10_ = _tmp9_->map;
#line 215 "../src/puzzle-view.vala"
		_tmp10__length1 = _tmp9_->map_length1;
#line 215 "../src/puzzle-view.vala"
		new_piece_id = puzzle_get_piece_id (_tmp7_, _tmp10_, (gint) _tmp10__length1, self->priv->piece_x, self->priv->piece_y);
#line 217 "../src/puzzle-view.vala"
		_tmp12_ = puzzle_view_get_piece_id (self);
#line 217 "../src/puzzle-view.vala"
		_tmp13_ = _tmp12_;
#line 217 "../src/puzzle-view.vala"
		if (_tmp13_ != '\0') {
#line 217 "../src/puzzle-view.vala"
			_tmp11_ = self->priv->piece_unmoved;
#line 1009 "puzzle-view.c"
		} else {
#line 217 "../src/puzzle-view.vala"
			_tmp11_ = FALSE;
#line 1013 "puzzle-view.c"
		}
#line 217 "../src/puzzle-view.vala"
		if (_tmp11_) {
#line 219 "../src/puzzle-view.vala"
			puzzle_view_set_piece_id (self, '\0');
#line 220 "../src/puzzle-view.vala"
			result = FALSE;
#line 220 "../src/puzzle-view.vala"
			return result;
#line 1023 "puzzle-view.c"
		}
#line 222 "../src/puzzle-view.vala"
		if (new_piece_id == ' ') {
#line 222 "../src/puzzle-view.vala"
			_tmp17_ = TRUE;
#line 1029 "puzzle-view.c"
		} else {
#line 222 "../src/puzzle-view.vala"
			_tmp17_ = new_piece_id == '.';
#line 1033 "puzzle-view.c"
		}
#line 222 "../src/puzzle-view.vala"
		if (_tmp17_) {
#line 222 "../src/puzzle-view.vala"
			_tmp16_ = TRUE;
#line 1039 "puzzle-view.c"
		} else {
#line 222 "../src/puzzle-view.vala"
			_tmp16_ = new_piece_id == '-';
#line 1043 "puzzle-view.c"
		}
#line 222 "../src/puzzle-view.vala"
		if (_tmp16_) {
#line 222 "../src/puzzle-view.vala"
			_tmp15_ = TRUE;
#line 1049 "puzzle-view.c"
		} else {
#line 223 "../src/puzzle-view.vala"
			_tmp15_ = new_piece_id == '#';
#line 1053 "puzzle-view.c"
		}
#line 222 "../src/puzzle-view.vala"
		if (_tmp15_) {
#line 222 "../src/puzzle-view.vala"
			_tmp14_ = TRUE;
#line 1059 "puzzle-view.c"
		} else {
			gchar _tmp18_;
			gchar _tmp19_;
#line 223 "../src/puzzle-view.vala"
			_tmp18_ = puzzle_view_get_piece_id (self);
#line 223 "../src/puzzle-view.vala"
			_tmp19_ = _tmp18_;
#line 223 "../src/puzzle-view.vala"
			_tmp14_ = new_piece_id == _tmp19_;
#line 1069 "puzzle-view.c"
		}
#line 222 "../src/puzzle-view.vala"
		if (_tmp14_) {
#line 224 "../src/puzzle-view.vala"
			result = FALSE;
#line 224 "../src/puzzle-view.vala"
			return result;
#line 1077 "puzzle-view.c"
		}
#line 226 "../src/puzzle-view.vala"
		self->priv->piece_unmoved = TRUE;
#line 227 "../src/puzzle-view.vala"
		puzzle_view_set_piece_id (self, new_piece_id);
#line 228 "../src/puzzle-view.vala"
		_tmp20_ = puzzle_view_get_puzzle (self);
#line 228 "../src/puzzle-view.vala"
		_tmp21_ = _tmp20_;
#line 228 "../src/puzzle-view.vala"
		_tmp22_ = puzzle_view_get_puzzle (self);
#line 228 "../src/puzzle-view.vala"
		_tmp23_ = _tmp22_;
#line 228 "../src/puzzle-view.vala"
		_tmp24_ = _tmp23_->map;
#line 228 "../src/puzzle-view.vala"
		_tmp24__length1 = _tmp23_->map_length1;
#line 228 "../src/puzzle-view.vala"
		_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup7 (_tmp24_, _tmp24__length1) : ((gpointer) _tmp24_);
#line 228 "../src/puzzle-view.vala"
		_tmp25__length1 = _tmp24__length1;
#line 228 "../src/puzzle-view.vala"
		_tmp21_->move_map = (g_free (_tmp21_->move_map), NULL);
#line 228 "../src/puzzle-view.vala"
		_tmp21_->move_map = _tmp25_;
#line 228 "../src/puzzle-view.vala"
		_tmp21_->move_map_length1 = _tmp25__length1;
#line 1105 "puzzle-view.c"
	}
#line 231 "../src/puzzle-view.vala"
	result = FALSE;
#line 231 "../src/puzzle-view.vala"
	return result;
#line 1111 "puzzle-view.c"
}

static gchar*
_vala_array_dup8 (gchar* self,
                  int length)
{
#line 245 "../src/puzzle-view.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 1120 "puzzle-view.c"
}

static gchar*
_vala_array_dup9 (gchar* self,
                  int length)
{
#line 258 "../src/puzzle-view.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 1129 "puzzle-view.c"
}

static gboolean
puzzle_view_real_button_release_event (GtkWidget* base,
                                       GdkEventButton* event)
{
	PuzzleView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 234 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 234 "../src/puzzle-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 236 "../src/puzzle-view.vala"
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1145 "puzzle-view.c"
		gchar _tmp1_;
		gchar _tmp2_;
#line 236 "../src/puzzle-view.vala"
		_tmp1_ = puzzle_view_get_piece_id (self);
#line 236 "../src/puzzle-view.vala"
		_tmp2_ = _tmp1_;
#line 236 "../src/puzzle-view.vala"
		_tmp0_ = _tmp2_ != '\0';
#line 1154 "puzzle-view.c"
	} else {
#line 236 "../src/puzzle-view.vala"
		_tmp0_ = FALSE;
#line 1158 "puzzle-view.c"
	}
#line 236 "../src/puzzle-view.vala"
	if (_tmp0_) {
#line 1162 "puzzle-view.c"
		gboolean _tmp3_ = FALSE;
		Puzzle* _tmp4_;
		Puzzle* _tmp5_;
		gchar _tmp6_;
		gchar _tmp7_;
#line 238 "../src/puzzle-view.vala"
		if (self->priv->piece_unmoved) {
#line 239 "../src/puzzle-view.vala"
			result = FALSE;
#line 239 "../src/puzzle-view.vala"
			return result;
#line 1174 "puzzle-view.c"
		}
#line 241 "../src/puzzle-view.vala"
		_tmp4_ = puzzle_view_get_puzzle (self);
#line 241 "../src/puzzle-view.vala"
		_tmp5_ = _tmp4_;
#line 241 "../src/puzzle-view.vala"
		_tmp6_ = puzzle_view_get_piece_id (self);
#line 241 "../src/puzzle-view.vala"
		_tmp7_ = _tmp6_;
#line 241 "../src/puzzle-view.vala"
		if (puzzle_movable (_tmp5_, (gint) _tmp7_)) {
#line 1186 "puzzle-view.c"
			Puzzle* _tmp8_;
			Puzzle* _tmp9_;
			Puzzle* _tmp10_;
			Puzzle* _tmp11_;
			gchar* _tmp12_;
			gint _tmp12__length1;
			Puzzle* _tmp13_;
			Puzzle* _tmp14_;
			gchar* _tmp15_;
			gint _tmp15__length1;
#line 241 "../src/puzzle-view.vala"
			_tmp8_ = puzzle_view_get_puzzle (self);
#line 241 "../src/puzzle-view.vala"
			_tmp9_ = _tmp8_;
#line 241 "../src/puzzle-view.vala"
			_tmp10_ = puzzle_view_get_puzzle (self);
#line 241 "../src/puzzle-view.vala"
			_tmp11_ = _tmp10_;
#line 241 "../src/puzzle-view.vala"
			_tmp12_ = _tmp11_->move_map;
#line 241 "../src/puzzle-view.vala"
			_tmp12__length1 = _tmp11_->move_map_length1;
#line 241 "../src/puzzle-view.vala"
			_tmp13_ = puzzle_view_get_puzzle (self);
#line 241 "../src/puzzle-view.vala"
			_tmp14_ = _tmp13_;
#line 241 "../src/puzzle-view.vala"
			_tmp15_ = _tmp14_->map;
#line 241 "../src/puzzle-view.vala"
			_tmp15__length1 = _tmp14_->map_length1;
#line 241 "../src/puzzle-view.vala"
			_tmp3_ = puzzle_mapcmp (_tmp9_, _tmp12_, (gint) _tmp12__length1, _tmp15_, (gint) _tmp15__length1);
#line 1219 "puzzle-view.c"
		} else {
#line 241 "../src/puzzle-view.vala"
			_tmp3_ = FALSE;
#line 1223 "puzzle-view.c"
		}
#line 241 "../src/puzzle-view.vala"
		if (_tmp3_) {
#line 1227 "puzzle-view.c"
			gboolean _tmp16_ = FALSE;
			gboolean _tmp30_ = FALSE;
			Puzzle* _tmp31_;
			Puzzle* _tmp32_;
			Puzzle* _tmp46_;
			Puzzle* _tmp47_;
			Puzzle* _tmp48_;
			Puzzle* _tmp49_;
			gchar* _tmp50_;
			gint _tmp50__length1;
			gchar* _tmp51_;
			gint _tmp51__length1;
			Puzzle* _tmp52_;
			Puzzle* _tmp53_;
#line 243 "../src/puzzle-view.vala"
			if (self->priv->last_piece_id == '\0') {
#line 243 "../src/puzzle-view.vala"
				_tmp16_ = TRUE;
#line 1246 "puzzle-view.c"
			} else {
				gchar _tmp17_;
				gchar _tmp18_;
#line 243 "../src/puzzle-view.vala"
				_tmp17_ = puzzle_view_get_piece_id (self);
#line 243 "../src/puzzle-view.vala"
				_tmp18_ = _tmp17_;
#line 243 "../src/puzzle-view.vala"
				_tmp16_ = self->priv->last_piece_id != _tmp18_;
#line 1256 "puzzle-view.c"
			}
#line 243 "../src/puzzle-view.vala"
			if (_tmp16_) {
#line 1260 "puzzle-view.c"
				Puzzle* _tmp19_;
				Puzzle* _tmp20_;
				Puzzle* _tmp21_;
				Puzzle* _tmp22_;
				gchar* _tmp23_;
				gint _tmp23__length1;
				gchar* _tmp24_;
				gint _tmp24__length1;
				Puzzle* _tmp25_;
				Puzzle* _tmp26_;
#line 245 "../src/puzzle-view.vala"
				_tmp19_ = puzzle_view_get_puzzle (self);
#line 245 "../src/puzzle-view.vala"
				_tmp20_ = _tmp19_;
#line 245 "../src/puzzle-view.vala"
				_tmp21_ = puzzle_view_get_puzzle (self);
#line 245 "../src/puzzle-view.vala"
				_tmp22_ = _tmp21_;
#line 245 "../src/puzzle-view.vala"
				_tmp23_ = _tmp22_->lastmove_map;
#line 245 "../src/puzzle-view.vala"
				_tmp23__length1 = _tmp22_->lastmove_map_length1;
#line 245 "../src/puzzle-view.vala"
				_tmp24_ = (_tmp23_ != NULL) ? _vala_array_dup8 (_tmp23_, _tmp23__length1) : ((gpointer) _tmp23_);
#line 245 "../src/puzzle-view.vala"
				_tmp24__length1 = _tmp23__length1;
#line 245 "../src/puzzle-view.vala"
				_tmp20_->undomove_map = (g_free (_tmp20_->undomove_map), NULL);
#line 245 "../src/puzzle-view.vala"
				_tmp20_->undomove_map = _tmp24_;
#line 245 "../src/puzzle-view.vala"
				_tmp20_->undomove_map_length1 = _tmp24__length1;
#line 246 "../src/puzzle-view.vala"
				_tmp25_ = puzzle_view_get_puzzle (self);
#line 246 "../src/puzzle-view.vala"
				_tmp26_ = _tmp25_;
#line 246 "../src/puzzle-view.vala"
				if (_tmp26_->moves < 999) {
#line 1299 "puzzle-view.c"
					Puzzle* _tmp27_;
					Puzzle* _tmp28_;
					gint _tmp29_;
#line 247 "../src/puzzle-view.vala"
					_tmp27_ = puzzle_view_get_puzzle (self);
#line 247 "../src/puzzle-view.vala"
					_tmp28_ = _tmp27_;
#line 247 "../src/puzzle-view.vala"
					_tmp29_ = _tmp28_->moves;
#line 247 "../src/puzzle-view.vala"
					_tmp28_->moves = _tmp29_ + 1;
#line 1311 "puzzle-view.c"
				}
			}
#line 250 "../src/puzzle-view.vala"
			_tmp31_ = puzzle_view_get_puzzle (self);
#line 250 "../src/puzzle-view.vala"
			_tmp32_ = _tmp31_;
#line 250 "../src/puzzle-view.vala"
			if (_tmp32_->moves > 0) {
#line 1320 "puzzle-view.c"
				Puzzle* _tmp33_;
				Puzzle* _tmp34_;
				Puzzle* _tmp35_;
				Puzzle* _tmp36_;
				gchar* _tmp37_;
				gint _tmp37__length1;
				Puzzle* _tmp38_;
				Puzzle* _tmp39_;
				gchar* _tmp40_;
				gint _tmp40__length1;
#line 250 "../src/puzzle-view.vala"
				_tmp33_ = puzzle_view_get_puzzle (self);
#line 250 "../src/puzzle-view.vala"
				_tmp34_ = _tmp33_;
#line 250 "../src/puzzle-view.vala"
				_tmp35_ = puzzle_view_get_puzzle (self);
#line 250 "../src/puzzle-view.vala"
				_tmp36_ = _tmp35_;
#line 250 "../src/puzzle-view.vala"
				_tmp37_ = _tmp36_->undomove_map;
#line 250 "../src/puzzle-view.vala"
				_tmp37__length1 = _tmp36_->undomove_map_length1;
#line 250 "../src/puzzle-view.vala"
				_tmp38_ = puzzle_view_get_puzzle (self);
#line 250 "../src/puzzle-view.vala"
				_tmp39_ = _tmp38_;
#line 250 "../src/puzzle-view.vala"
				_tmp40_ = _tmp39_->map;
#line 250 "../src/puzzle-view.vala"
				_tmp40__length1 = _tmp39_->map_length1;
#line 250 "../src/puzzle-view.vala"
				_tmp30_ = !puzzle_mapcmp (_tmp34_, _tmp37_, (gint) _tmp37__length1, _tmp40_, (gint) _tmp40__length1);
#line 1353 "puzzle-view.c"
			} else {
#line 250 "../src/puzzle-view.vala"
				_tmp30_ = FALSE;
#line 1357 "puzzle-view.c"
			}
#line 250 "../src/puzzle-view.vala"
			if (_tmp30_) {
#line 1361 "puzzle-view.c"
				Puzzle* _tmp41_;
				Puzzle* _tmp42_;
				gint _tmp43_;
#line 252 "../src/puzzle-view.vala"
				_tmp41_ = puzzle_view_get_puzzle (self);
#line 252 "../src/puzzle-view.vala"
				_tmp42_ = _tmp41_;
#line 252 "../src/puzzle-view.vala"
				_tmp43_ = _tmp42_->moves;
#line 252 "../src/puzzle-view.vala"
				_tmp42_->moves = _tmp43_ - 1;
#line 253 "../src/puzzle-view.vala"
				self->priv->last_piece_id = '\0';
#line 1375 "puzzle-view.c"
			} else {
				gchar _tmp44_;
				gchar _tmp45_;
#line 256 "../src/puzzle-view.vala"
				_tmp44_ = puzzle_view_get_piece_id (self);
#line 256 "../src/puzzle-view.vala"
				_tmp45_ = _tmp44_;
#line 256 "../src/puzzle-view.vala"
				self->priv->last_piece_id = _tmp45_;
#line 1385 "puzzle-view.c"
			}
#line 258 "../src/puzzle-view.vala"
			_tmp46_ = puzzle_view_get_puzzle (self);
#line 258 "../src/puzzle-view.vala"
			_tmp47_ = _tmp46_;
#line 258 "../src/puzzle-view.vala"
			_tmp48_ = puzzle_view_get_puzzle (self);
#line 258 "../src/puzzle-view.vala"
			_tmp49_ = _tmp48_;
#line 258 "../src/puzzle-view.vala"
			_tmp50_ = _tmp49_->map;
#line 258 "../src/puzzle-view.vala"
			_tmp50__length1 = _tmp49_->map_length1;
#line 258 "../src/puzzle-view.vala"
			_tmp51_ = (_tmp50_ != NULL) ? _vala_array_dup9 (_tmp50_, _tmp50__length1) : ((gpointer) _tmp50_);
#line 258 "../src/puzzle-view.vala"
			_tmp51__length1 = _tmp50__length1;
#line 258 "../src/puzzle-view.vala"
			_tmp47_->lastmove_map = (g_free (_tmp47_->lastmove_map), NULL);
#line 258 "../src/puzzle-view.vala"
			_tmp47_->lastmove_map = _tmp51_;
#line 258 "../src/puzzle-view.vala"
			_tmp47_->lastmove_map_length1 = _tmp51__length1;
#line 260 "../src/puzzle-view.vala"
			_tmp52_ = puzzle_view_get_puzzle (self);
#line 260 "../src/puzzle-view.vala"
			_tmp53_ = _tmp52_;
#line 260 "../src/puzzle-view.vala"
			g_signal_emit_by_name (_tmp53_, "moved");
#line 1415 "puzzle-view.c"
		}
#line 262 "../src/puzzle-view.vala"
		puzzle_view_set_piece_id (self, '\0');
#line 1419 "puzzle-view.c"
	}
#line 265 "../src/puzzle-view.vala"
	result = FALSE;
#line 265 "../src/puzzle-view.vala"
	return result;
#line 1425 "puzzle-view.c"
}

static gboolean
puzzle_view_real_motion_notify_event (GtkWidget* base,
                                      GdkEventMotion* event)
{
	PuzzleView * self;
	gboolean result = FALSE;
	gint new_piece_x = 0;
	gint new_piece_y = 0;
	gchar _tmp0_;
	gchar _tmp1_;
#line 268 "../src/puzzle-view.vala"
	self = (PuzzleView*) base;
#line 268 "../src/puzzle-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 272 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_piece_id (self);
#line 272 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 272 "../src/puzzle-view.vala"
	if (_tmp1_ != '\0') {
#line 1448 "puzzle-view.c"
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		Puzzle* _tmp9_;
		Puzzle* _tmp10_;
		Puzzle* _tmp13_;
		Puzzle* _tmp14_;
		gchar _tmp15_;
		gchar _tmp16_;
#line 274 "../src/puzzle-view.vala"
		_tmp2_ = puzzle_view_get_tile_size (self);
#line 274 "../src/puzzle-view.vala"
		_tmp3_ = _tmp2_;
#line 274 "../src/puzzle-view.vala"
		new_piece_x = ((gint) (event->x - self->priv->kx)) / _tmp3_;
#line 275 "../src/puzzle-view.vala"
		_tmp4_ = puzzle_view_get_tile_size (self);
#line 275 "../src/puzzle-view.vala"
		_tmp5_ = _tmp4_;
#line 275 "../src/puzzle-view.vala"
		new_piece_y = ((gint) (event->y - self->priv->ky)) / _tmp5_;
#line 276 "../src/puzzle-view.vala"
		_tmp9_ = puzzle_view_get_puzzle (self);
#line 276 "../src/puzzle-view.vala"
		_tmp10_ = _tmp9_;
#line 276 "../src/puzzle-view.vala"
		if (new_piece_x >= _tmp10_->width) {
#line 276 "../src/puzzle-view.vala"
			_tmp8_ = TRUE;
#line 1482 "puzzle-view.c"
		} else {
#line 276 "../src/puzzle-view.vala"
			_tmp8_ = event->x < ((gdouble) 0);
#line 1486 "puzzle-view.c"
		}
#line 276 "../src/puzzle-view.vala"
		if (_tmp8_) {
#line 276 "../src/puzzle-view.vala"
			_tmp7_ = TRUE;
#line 1492 "puzzle-view.c"
		} else {
			Puzzle* _tmp11_;
			Puzzle* _tmp12_;
#line 276 "../src/puzzle-view.vala"
			_tmp11_ = puzzle_view_get_puzzle (self);
#line 276 "../src/puzzle-view.vala"
			_tmp12_ = _tmp11_;
#line 276 "../src/puzzle-view.vala"
			_tmp7_ = new_piece_y >= _tmp12_->height;
#line 1502 "puzzle-view.c"
		}
#line 276 "../src/puzzle-view.vala"
		if (_tmp7_) {
#line 276 "../src/puzzle-view.vala"
			_tmp6_ = TRUE;
#line 1508 "puzzle-view.c"
		} else {
#line 276 "../src/puzzle-view.vala"
			_tmp6_ = event->y < ((gdouble) 0);
#line 1512 "puzzle-view.c"
		}
#line 276 "../src/puzzle-view.vala"
		if (_tmp6_) {
#line 277 "../src/puzzle-view.vala"
			result = FALSE;
#line 277 "../src/puzzle-view.vala"
			return result;
#line 1520 "puzzle-view.c"
		}
#line 278 "../src/puzzle-view.vala"
		_tmp13_ = puzzle_view_get_puzzle (self);
#line 278 "../src/puzzle-view.vala"
		_tmp14_ = _tmp13_;
#line 278 "../src/puzzle-view.vala"
		_tmp15_ = puzzle_view_get_piece_id (self);
#line 278 "../src/puzzle-view.vala"
		_tmp16_ = _tmp15_;
#line 278 "../src/puzzle-view.vala"
		if (puzzle_move_piece (_tmp14_, _tmp16_, self->priv->piece_x, self->priv->piece_y, new_piece_x, new_piece_y)) {
#line 280 "../src/puzzle-view.vala"
			self->priv->piece_unmoved = FALSE;
#line 281 "../src/puzzle-view.vala"
			self->priv->piece_x = new_piece_x;
#line 282 "../src/puzzle-view.vala"
			self->priv->piece_y = new_piece_y;
#line 1538 "puzzle-view.c"
		}
#line 284 "../src/puzzle-view.vala"
		result = TRUE;
#line 284 "../src/puzzle-view.vala"
		return result;
#line 1544 "puzzle-view.c"
	}
#line 287 "../src/puzzle-view.vala"
	result = FALSE;
#line 287 "../src/puzzle-view.vala"
	return result;
#line 1550 "puzzle-view.c"
}

static void
puzzle_view_puzzle_changed_cb (PuzzleView* self)
{
#line 290 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/puzzle-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1560 "puzzle-view.c"
}

static gchar
puzzle_view_get_piece_id (PuzzleView* self)
{
	gchar result;
#line 29 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 29 "../src/puzzle-view.vala"
	result = self->priv->_piece_id;
#line 29 "../src/puzzle-view.vala"
	return result;
#line 1573 "puzzle-view.c"
}

static void
puzzle_view_set_piece_id (PuzzleView* self,
                          gchar value)
{
#line 30 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/puzzle-view.vala"
	self->priv->_piece_id = value;
#line 30 "../src/puzzle-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1586 "puzzle-view.c"
}

Puzzle*
puzzle_view_get_puzzle (PuzzleView* self)
{
	Puzzle* result;
	Puzzle* _tmp0_;
#line 45 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->_puzzle;
#line 45 "../src/puzzle-view.vala"
	result = _tmp0_;
#line 45 "../src/puzzle-view.vala"
	return result;
#line 1602 "puzzle-view.c"
}

static void
_puzzle_view_puzzle_changed_cb_puzzle_changed (Puzzle* _sender,
                                               gpointer self)
{
#line 51 "../src/puzzle-view.vala"
	puzzle_view_puzzle_changed_cb ((PuzzleView*) self);
#line 1611 "puzzle-view.c"
}

void
puzzle_view_set_puzzle (PuzzleView* self,
                        Puzzle* value)
{
	Puzzle* _tmp0_;
	Puzzle* _tmp2_;
	Puzzle* _tmp3_;
#line 46 "../src/puzzle-view.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/puzzle-view.vala"
	_tmp0_ = self->priv->_puzzle;
#line 48 "../src/puzzle-view.vala"
	if (_tmp0_ != NULL) {
#line 1627 "puzzle-view.c"
		Puzzle* _tmp1_;
#line 49 "../src/puzzle-view.vala"
		_tmp1_ = self->priv->_puzzle;
#line 49 "../src/puzzle-view.vala"
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
#line 1633 "puzzle-view.c"
	}
#line 50 "../src/puzzle-view.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 50 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->_puzzle);
#line 50 "../src/puzzle-view.vala"
	self->priv->_puzzle = _tmp2_;
#line 51 "../src/puzzle-view.vala"
	_tmp3_ = self->priv->_puzzle;
#line 51 "../src/puzzle-view.vala"
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _puzzle_view_puzzle_changed_cb_puzzle_changed, self, 0);
#line 52 "../src/puzzle-view.vala"
	self->priv->piece_x = 0;
#line 53 "../src/puzzle-view.vala"
	self->priv->piece_y = 0;
#line 54 "../src/puzzle-view.vala"
	puzzle_view_set_piece_id (self, '\0');
#line 55 "../src/puzzle-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 46 "../src/puzzle-view.vala"
	g_object_notify_by_pspec ((GObject *) self, puzzle_view_properties[PUZZLE_VIEW_PUZZLE_PROPERTY]);
#line 1655 "puzzle-view.c"
}

static gint
puzzle_view_get_tile_size (PuzzleView* self)
{
	gint result;
	gint s = 0;
	Puzzle* _tmp0_;
	Puzzle* _tmp1_;
	Puzzle* _tmp2_;
	Puzzle* _tmp3_;
#line 61 "../src/puzzle-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 63 "../src/puzzle-view.vala"
	_tmp0_ = puzzle_view_get_puzzle (self);
#line 63 "../src/puzzle-view.vala"
	_tmp1_ = _tmp0_;
#line 63 "../src/puzzle-view.vala"
	_tmp2_ = puzzle_view_get_puzzle (self);
#line 63 "../src/puzzle-view.vala"
	_tmp3_ = _tmp2_;
#line 63 "../src/puzzle-view.vala"
	s = MIN ((gtk_widget_get_allocated_width ((GtkWidget*) self) - PUZZLE_VIEW_SPACE_PADDING) / _tmp1_->width, (gtk_widget_get_allocated_height ((GtkWidget*) self) - PUZZLE_VIEW_SPACE_PADDING) / _tmp3_->height);
#line 65 "../src/puzzle-view.vala"
	if ((s % 2) != 0) {
#line 1681 "puzzle-view.c"
		gint _tmp4_;
#line 66 "../src/puzzle-view.vala"
		_tmp4_ = s;
#line 66 "../src/puzzle-view.vala"
		s = _tmp4_ - 1;
#line 1687 "puzzle-view.c"
	}
#line 67 "../src/puzzle-view.vala"
	result = s;
#line 67 "../src/puzzle-view.vala"
	return result;
#line 1693 "puzzle-view.c"
}

static void
puzzle_view_class_init (PuzzleViewClass * klass,
                        gpointer klass_data)
{
#line 11 "../src/puzzle-view.vala"
	puzzle_view_parent_class = g_type_class_peek_parent (klass);
#line 11 "../src/puzzle-view.vala"
	g_type_class_adjust_private_offset (klass, &PuzzleView_private_offset);
#line 11 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) puzzle_view_real_draw;
#line 11 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) puzzle_view_real_button_press_event;
#line 11 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) puzzle_view_real_button_release_event;
#line 11 "../src/puzzle-view.vala"
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) puzzle_view_real_motion_notify_event;
#line 11 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_puzzle_view_get_property;
#line 11 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_puzzle_view_set_property;
#line 11 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (klass)->finalize = puzzle_view_finalize;
#line 11 "../src/puzzle-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_VIEW_PUZZLE_PROPERTY, puzzle_view_properties[PUZZLE_VIEW_PUZZLE_PROPERTY] = g_param_spec_object ("puzzle", "puzzle", "puzzle", TYPE_PUZZLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1720 "puzzle-view.c"
}

static void
puzzle_view_instance_init (PuzzleView * self,
                           gpointer klass)
{
#line 11 "../src/puzzle-view.vala"
	self->priv = puzzle_view_get_instance_private (self);
#line 20 "../src/puzzle-view.vala"
	self->priv->render_size = 0;
#line 22 "../src/puzzle-view.vala"
	self->priv->piece_x = 0;
#line 23 "../src/puzzle-view.vala"
	self->priv->piece_y = 0;
#line 24 "../src/puzzle-view.vala"
	self->priv->piece_unmoved = FALSE;
#line 26 "../src/puzzle-view.vala"
	self->priv->_piece_id = '\0';
#line 33 "../src/puzzle-view.vala"
	self->priv->last_piece_id = '\0';
#line 35 "../src/puzzle-view.vala"
	self->priv->kx = (gdouble) 0;
#line 36 "../src/puzzle-view.vala"
	self->priv->ky = (gdouble) 0;
#line 38 "../src/puzzle-view.vala"
	self->priv->tiles_handle = NULL;
#line 39 "../src/puzzle-view.vala"
	self->priv->image_file = NULL;
#line 40 "../src/puzzle-view.vala"
	self->priv->surface = NULL;
#line 42 "../src/puzzle-view.vala"
	self->priv->_puzzle = NULL;
#line 1753 "puzzle-view.c"
}

static void
puzzle_view_finalize (GObject * obj)
{
	PuzzleView * self;
#line 11 "../src/puzzle-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE_VIEW, PuzzleView);
#line 38 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->tiles_handle);
#line 39 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->image_file);
#line 40 "../src/puzzle-view.vala"
	_cairo_surface_destroy0 (self->priv->surface);
#line 42 "../src/puzzle-view.vala"
	_g_object_unref0 (self->priv->_puzzle);
#line 11 "../src/puzzle-view.vala"
	G_OBJECT_CLASS (puzzle_view_parent_class)->finalize (obj);
#line 1772 "puzzle-view.c"
}

GType
puzzle_view_get_type (void)
{
	static volatile gsize puzzle_view_type_id__volatile = 0;
	if (g_once_init_enter (&puzzle_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PuzzleViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PuzzleView), 0, (GInstanceInitFunc) puzzle_view_instance_init, NULL };
		GType puzzle_view_type_id;
		puzzle_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PuzzleView", &g_define_type_info, 0);
		PuzzleView_private_offset = g_type_add_instance_private (puzzle_view_type_id, sizeof (PuzzleViewPrivate));
		g_once_init_leave (&puzzle_view_type_id__volatile, puzzle_view_type_id);
	}
	return puzzle_view_type_id__volatile;
}

static void
_vala_puzzle_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	PuzzleView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE_VIEW, PuzzleView);
#line 11 "../src/puzzle-view.vala"
	switch (property_id) {
#line 11 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_PUZZLE_PROPERTY:
#line 11 "../src/puzzle-view.vala"
		g_value_set_object (value, puzzle_view_get_puzzle (self));
#line 11 "../src/puzzle-view.vala"
		break;
#line 1805 "puzzle-view.c"
		default:
#line 11 "../src/puzzle-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 11 "../src/puzzle-view.vala"
		break;
#line 1811 "puzzle-view.c"
	}
}

static void
_vala_puzzle_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	PuzzleView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE_VIEW, PuzzleView);
#line 11 "../src/puzzle-view.vala"
	switch (property_id) {
#line 11 "../src/puzzle-view.vala"
		case PUZZLE_VIEW_PUZZLE_PROPERTY:
#line 11 "../src/puzzle-view.vala"
		puzzle_view_set_puzzle (self, g_value_get_object (value));
#line 11 "../src/puzzle-view.vala"
		break;
#line 1831 "puzzle-view.c"
		default:
#line 11 "../src/puzzle-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 11 "../src/puzzle-view.vala"
		break;
#line 1837 "puzzle-view.c"
	}
}

