/* puzzle.c generated by valac 0.44.0, the Vala compiler
 * generated from puzzle.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/*
  1   2   4

  8   *   16

  32  64  128
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;
typedef struct _PuzzlePrivate PuzzlePrivate;
enum  {
	PUZZLE_0_PROPERTY,
	PUZZLE_NUM_PROPERTIES
};
static GParamSpec* puzzle_properties[PUZZLE_NUM_PROPERTIES];
enum  {
	PUZZLE_CHANGED_SIGNAL,
	PUZZLE_MOVED_SIGNAL,
	PUZZLE_NUM_SIGNALS
};
static guint puzzle_signals[PUZZLE_NUM_SIGNALS] = {0};

struct _Puzzle {
	GObject parent_instance;
	PuzzlePrivate * priv;
	gint width;
	gint height;
	gchar* map;
	gint map_length1;
	gchar* move_map;
	gint move_map_length1;
	gchar* orig_map;
	gint orig_map_length1;
	gchar* lastmove_map;
	gint lastmove_map_length1;
	gchar* undomove_map;
	gint undomove_map_length1;
	gint moves;
};

struct _PuzzleClass {
	GObjectClass parent_class;
};

static gpointer puzzle_parent_class = NULL;

GType puzzle_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
Puzzle* puzzle_new (gint width,
                    gint height,
                    const gchar* data);
Puzzle* puzzle_construct (GType object_type,
                          gint width,
                          gint height,
                          const gchar* data);
static gchar* _vala_array_dup1 (gchar* self,
                         int length);
static gchar* _vala_array_dup2 (gchar* self,
                         int length);
static void puzzle_set_piece_id (Puzzle* self,
                          gchar* src,
                          gint src_length1,
                          gint x,
                          gint y,
                          gchar id);
static gchar* _vala_array_dup3 (gchar* self,
                         int length);
static gchar* _vala_array_dup4 (gchar* self,
                         int length);
gchar puzzle_get_piece_id (Puzzle* self,
                           gchar* src,
                           gint src_length1,
                           gint x,
                           gint y);
gint puzzle_get_piece_nr (Puzzle* self,
                          gint x,
                          gint y);
gboolean puzzle_game_over (Puzzle* self);
gboolean puzzle_mapcmp (Puzzle* self,
                        gchar* m1,
                        gint m1_length1,
                        gchar* m2,
                        gint m2_length1);
gboolean puzzle_movable (Puzzle* self,
                         gint id);
gboolean puzzle_move_piece (Puzzle* self,
                            gchar id,
                            gint x1,
                            gint y1,
                            gint x2,
                            gint y2);
static gboolean puzzle_check_valid_move (Puzzle* self,
                                  gint id,
                                  gint dx,
                                  gint dy);
static gboolean puzzle_do_move_piece (Puzzle* self,
                               gchar id,
                               gint dx,
                               gint dy);
static gchar* _vala_array_dup5 (gchar* self,
                         int length);
static gchar* _vala_array_dup6 (gchar* self,
                         int length);
static void puzzle_finalize (GObject * obj);

const gint image_map[110] = {0, 0, 64, 1, 66, 2, 2, 3, 16, 4, 24, 5, 8, 6, 208, 7, 248, 8, 104, 9, 214, 10, 255, 11, 107, 12, 22, 13, 31, 14, 11, 15, 18, 16, 10, 17, 80, 18, 72, 19, 56, 5, 152, 5, 70, 2, 67, 2, 194, 2, 98, 2, 9, 6, 20, 4, 144, 4, 3, 3, 40, 6, 25, 5, 28, 5, 96, 1, 19, 16, 201, 19, 146, 16, 198, 2, 84, 18, 46, 17, 112, 18, 6, 3, 184, 5, 192, 1, 147, 16, 73, 19, 42, 17, 200, 19, 99, 2, 116, 18, 29, 5, 14, 17, 26, 25, 224, 1, -1, -1};

static gchar*
_vala_array_dup1 (gchar* self,
                  int length)
{
#line 108 "../src/puzzle.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 140 "puzzle.c"
}

static gchar*
_vala_array_dup2 (gchar* self,
                  int length)
{
#line 109 "../src/puzzle.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 149 "puzzle.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 166 "puzzle.c"
}

static gchar*
_vala_array_dup3 (gchar* self,
                  int length)
{
#line 122 "../src/puzzle.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 175 "puzzle.c"
}

static gchar*
_vala_array_dup4 (gchar* self,
                  int length)
{
#line 123 "../src/puzzle.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 184 "puzzle.c"
}

Puzzle*
puzzle_construct (GType object_type,
                  gint width,
                  gint height,
                  const gchar* data)
{
	Puzzle * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	gint _tmp14__length1;
#line 103 "../src/puzzle.vala"
	self = (Puzzle*) g_object_new (object_type, NULL);
#line 105 "../src/puzzle.vala"
	self->width = width;
#line 106 "../src/puzzle.vala"
	self->height = height;
#line 107 "../src/puzzle.vala"
	_tmp0_ = g_new0 (gchar, (width + 2) * (height + 2));
#line 107 "../src/puzzle.vala"
	self->map = (g_free (self->map), NULL);
#line 107 "../src/puzzle.vala"
	self->map = _tmp0_;
#line 107 "../src/puzzle.vala"
	self->map_length1 = (width + 2) * (height + 2);
#line 108 "../src/puzzle.vala"
	_tmp1_ = self->map;
#line 108 "../src/puzzle.vala"
	_tmp1__length1 = self->map_length1;
#line 108 "../src/puzzle.vala"
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup1 (_tmp1_, _tmp1__length1) : ((gpointer) _tmp1_);
#line 108 "../src/puzzle.vala"
	_tmp2__length1 = _tmp1__length1;
#line 108 "../src/puzzle.vala"
	self->move_map = (g_free (self->move_map), NULL);
#line 108 "../src/puzzle.vala"
	self->move_map = _tmp2_;
#line 108 "../src/puzzle.vala"
	self->move_map_length1 = _tmp2__length1;
#line 109 "../src/puzzle.vala"
	_tmp3_ = self->map;
#line 109 "../src/puzzle.vala"
	_tmp3__length1 = self->map_length1;
#line 109 "../src/puzzle.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup2 (_tmp3_, _tmp3__length1) : ((gpointer) _tmp3_);
#line 109 "../src/puzzle.vala"
	_tmp4__length1 = _tmp3__length1;
#line 109 "../src/puzzle.vala"
	self->undomove_map = (g_free (self->undomove_map), NULL);
#line 109 "../src/puzzle.vala"
	self->undomove_map = _tmp4_;
#line 109 "../src/puzzle.vala"
	self->undomove_map_length1 = _tmp4__length1;
#line 110 "../src/puzzle.vala"
	if (data != NULL) {
#line 255 "puzzle.c"
		gint i = 0;
#line 112 "../src/puzzle.vala"
		i = 0;
#line 259 "puzzle.c"
		{
			gint y = 0;
#line 113 "../src/puzzle.vala"
			y = 0;
#line 264 "puzzle.c"
			{
				gboolean _tmp5_ = FALSE;
#line 113 "../src/puzzle.vala"
				_tmp5_ = TRUE;
#line 113 "../src/puzzle.vala"
				while (TRUE) {
#line 113 "../src/puzzle.vala"
					if (!_tmp5_) {
#line 273 "puzzle.c"
						gint _tmp6_;
#line 113 "../src/puzzle.vala"
						_tmp6_ = y;
#line 113 "../src/puzzle.vala"
						y = _tmp6_ + 1;
#line 279 "puzzle.c"
					}
#line 113 "../src/puzzle.vala"
					_tmp5_ = FALSE;
#line 113 "../src/puzzle.vala"
					if (!(y < height)) {
#line 113 "../src/puzzle.vala"
						break;
#line 287 "puzzle.c"
					}
					{
						gint x = 0;
#line 115 "../src/puzzle.vala"
						x = 0;
#line 293 "puzzle.c"
						{
							gboolean _tmp7_ = FALSE;
#line 115 "../src/puzzle.vala"
							_tmp7_ = TRUE;
#line 115 "../src/puzzle.vala"
							while (TRUE) {
#line 300 "puzzle.c"
								gchar* _tmp9_;
								gint _tmp9__length1;
								gint _tmp10_;
#line 115 "../src/puzzle.vala"
								if (!_tmp7_) {
#line 306 "puzzle.c"
									gint _tmp8_;
#line 115 "../src/puzzle.vala"
									_tmp8_ = x;
#line 115 "../src/puzzle.vala"
									x = _tmp8_ + 1;
#line 312 "puzzle.c"
								}
#line 115 "../src/puzzle.vala"
								_tmp7_ = FALSE;
#line 115 "../src/puzzle.vala"
								if (!(x < width)) {
#line 115 "../src/puzzle.vala"
									break;
#line 320 "puzzle.c"
								}
#line 117 "../src/puzzle.vala"
								_tmp9_ = self->map;
#line 117 "../src/puzzle.vala"
								_tmp9__length1 = self->map_length1;
#line 117 "../src/puzzle.vala"
								puzzle_set_piece_id (self, _tmp9_, (gint) _tmp9__length1, x, y, string_get (data, (glong) i));
#line 118 "../src/puzzle.vala"
								_tmp10_ = i;
#line 118 "../src/puzzle.vala"
								i = _tmp10_ + 1;
#line 332 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
#line 122 "../src/puzzle.vala"
	_tmp11_ = self->map;
#line 122 "../src/puzzle.vala"
	_tmp11__length1 = self->map_length1;
#line 122 "../src/puzzle.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup3 (_tmp11_, _tmp11__length1) : ((gpointer) _tmp11_);
#line 122 "../src/puzzle.vala"
	_tmp12__length1 = _tmp11__length1;
#line 122 "../src/puzzle.vala"
	self->orig_map = (g_free (self->orig_map), NULL);
#line 122 "../src/puzzle.vala"
	self->orig_map = _tmp12_;
#line 122 "../src/puzzle.vala"
	self->orig_map_length1 = _tmp12__length1;
#line 123 "../src/puzzle.vala"
	_tmp13_ = self->map;
#line 123 "../src/puzzle.vala"
	_tmp13__length1 = self->map_length1;
#line 123 "../src/puzzle.vala"
	_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup4 (_tmp13_, _tmp13__length1) : ((gpointer) _tmp13_);
#line 123 "../src/puzzle.vala"
	_tmp14__length1 = _tmp13__length1;
#line 123 "../src/puzzle.vala"
	self->lastmove_map = (g_free (self->lastmove_map), NULL);
#line 123 "../src/puzzle.vala"
	self->lastmove_map = _tmp14_;
#line 123 "../src/puzzle.vala"
	self->lastmove_map_length1 = _tmp14__length1;
#line 103 "../src/puzzle.vala"
	return self;
#line 370 "puzzle.c"
}

Puzzle*
puzzle_new (gint width,
            gint height,
            const gchar* data)
{
#line 103 "../src/puzzle.vala"
	return puzzle_construct (TYPE_PUZZLE, width, height, data);
#line 380 "puzzle.c"
}

gchar
puzzle_get_piece_id (Puzzle* self,
                     gchar* src,
                     gint src_length1,
                     gint x,
                     gint y)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 126 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 128 "../src/puzzle.vala"
	_tmp0_ = src[(x + 1) + ((y + 1) * (self->width + 2))];
#line 128 "../src/puzzle.vala"
	result = _tmp0_;
#line 128 "../src/puzzle.vala"
	return result;
#line 400 "puzzle.c"
}

static void
puzzle_set_piece_id (Puzzle* self,
                     gchar* src,
                     gint src_length1,
                     gint x,
                     gint y,
                     gchar id)
{
#line 131 "../src/puzzle.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/puzzle.vala"
	src[(x + 1) + ((y + 1) * (self->width + 2))] = id;
#line 415 "puzzle.c"
}

gint
puzzle_get_piece_nr (Puzzle* self,
                     gint x,
                     gint y)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar c = '\0';
	gchar* _tmp2_;
	gint _tmp2__length1;
	gchar _tmp3_;
	gint nr = 0;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar _tmp5_;
	gchar* _tmp6_;
	gint _tmp6__length1;
	gchar _tmp7_;
	gchar* _tmp8_;
	gint _tmp8__length1;
	gchar _tmp9_;
	gchar* _tmp10_;
	gint _tmp10__length1;
	gchar _tmp11_;
	gchar* _tmp12_;
	gint _tmp12__length1;
	gchar _tmp13_;
	gchar* _tmp14_;
	gint _tmp14__length1;
	gchar _tmp15_;
	gchar* _tmp16_;
	gint _tmp16__length1;
	gchar _tmp17_;
	gchar* _tmp18_;
	gint _tmp18__length1;
	gchar _tmp19_;
	gint i = 0;
	gint _tmp23_;
#line 136 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 138 "../src/puzzle.vala"
	_tmp0_ = x;
#line 138 "../src/puzzle.vala"
	x = _tmp0_ + 1;
#line 139 "../src/puzzle.vala"
	_tmp1_ = y;
#line 139 "../src/puzzle.vala"
	y = _tmp1_ + 1;
#line 141 "../src/puzzle.vala"
	_tmp2_ = self->map;
#line 141 "../src/puzzle.vala"
	_tmp2__length1 = self->map_length1;
#line 141 "../src/puzzle.vala"
	_tmp3_ = _tmp2_[x + (y * (self->width + 2))];
#line 141 "../src/puzzle.vala"
	c = _tmp3_;
#line 142 "../src/puzzle.vala"
	if (c == '-') {
#line 143 "../src/puzzle.vala"
		result = 23;
#line 143 "../src/puzzle.vala"
		return result;
#line 481 "puzzle.c"
	}
#line 144 "../src/puzzle.vala"
	if (c == ' ') {
#line 145 "../src/puzzle.vala"
		result = 21;
#line 145 "../src/puzzle.vala"
		return result;
#line 489 "puzzle.c"
	}
#line 146 "../src/puzzle.vala"
	if (c == '.') {
#line 147 "../src/puzzle.vala"
		result = 20;
#line 147 "../src/puzzle.vala"
		return result;
#line 497 "puzzle.c"
	}
#line 149 "../src/puzzle.vala"
	nr = 0;
#line 150 "../src/puzzle.vala"
	_tmp4_ = self->map;
#line 150 "../src/puzzle.vala"
	_tmp4__length1 = self->map_length1;
#line 150 "../src/puzzle.vala"
	_tmp5_ = _tmp4_[(x - 1) + ((y - 1) * (self->width + 2))];
#line 150 "../src/puzzle.vala"
	if (_tmp5_ == c) {
#line 151 "../src/puzzle.vala"
		nr = nr + 1;
#line 511 "puzzle.c"
	}
#line 152 "../src/puzzle.vala"
	_tmp6_ = self->map;
#line 152 "../src/puzzle.vala"
	_tmp6__length1 = self->map_length1;
#line 152 "../src/puzzle.vala"
	_tmp7_ = _tmp6_[(x - 0) + ((y - 1) * (self->width + 2))];
#line 152 "../src/puzzle.vala"
	if (_tmp7_ == c) {
#line 153 "../src/puzzle.vala"
		nr = nr + 2;
#line 523 "puzzle.c"
	}
#line 154 "../src/puzzle.vala"
	_tmp8_ = self->map;
#line 154 "../src/puzzle.vala"
	_tmp8__length1 = self->map_length1;
#line 154 "../src/puzzle.vala"
	_tmp9_ = _tmp8_[(x + 1) + ((y - 1) * (self->width + 2))];
#line 154 "../src/puzzle.vala"
	if (_tmp9_ == c) {
#line 155 "../src/puzzle.vala"
		nr = nr + 4;
#line 535 "puzzle.c"
	}
#line 156 "../src/puzzle.vala"
	_tmp10_ = self->map;
#line 156 "../src/puzzle.vala"
	_tmp10__length1 = self->map_length1;
#line 156 "../src/puzzle.vala"
	_tmp11_ = _tmp10_[(x - 1) + ((y - 0) * (self->width + 2))];
#line 156 "../src/puzzle.vala"
	if (_tmp11_ == c) {
#line 157 "../src/puzzle.vala"
		nr = nr + 8;
#line 547 "puzzle.c"
	}
#line 158 "../src/puzzle.vala"
	_tmp12_ = self->map;
#line 158 "../src/puzzle.vala"
	_tmp12__length1 = self->map_length1;
#line 158 "../src/puzzle.vala"
	_tmp13_ = _tmp12_[(x + 1) + ((y - 0) * (self->width + 2))];
#line 158 "../src/puzzle.vala"
	if (_tmp13_ == c) {
#line 159 "../src/puzzle.vala"
		nr = nr + 16;
#line 559 "puzzle.c"
	}
#line 160 "../src/puzzle.vala"
	_tmp14_ = self->map;
#line 160 "../src/puzzle.vala"
	_tmp14__length1 = self->map_length1;
#line 160 "../src/puzzle.vala"
	_tmp15_ = _tmp14_[(x - 1) + ((y + 1) * (self->width + 2))];
#line 160 "../src/puzzle.vala"
	if (_tmp15_ == c) {
#line 161 "../src/puzzle.vala"
		nr = nr + 32;
#line 571 "puzzle.c"
	}
#line 162 "../src/puzzle.vala"
	_tmp16_ = self->map;
#line 162 "../src/puzzle.vala"
	_tmp16__length1 = self->map_length1;
#line 162 "../src/puzzle.vala"
	_tmp17_ = _tmp16_[(x - 0) + ((y + 1) * (self->width + 2))];
#line 162 "../src/puzzle.vala"
	if (_tmp17_ == c) {
#line 163 "../src/puzzle.vala"
		nr = nr + 64;
#line 583 "puzzle.c"
	}
#line 164 "../src/puzzle.vala"
	_tmp18_ = self->map;
#line 164 "../src/puzzle.vala"
	_tmp18__length1 = self->map_length1;
#line 164 "../src/puzzle.vala"
	_tmp19_ = _tmp18_[(x + 1) + ((y + 1) * (self->width + 2))];
#line 164 "../src/puzzle.vala"
	if (_tmp19_ == c) {
#line 165 "../src/puzzle.vala"
		nr = nr + 128;
#line 595 "puzzle.c"
	}
#line 167 "../src/puzzle.vala"
	i = 0;
#line 168 "../src/puzzle.vala"
	while (TRUE) {
#line 601 "puzzle.c"
		gboolean _tmp20_ = FALSE;
		gint _tmp21_;
#line 168 "../src/puzzle.vala"
		_tmp21_ = image_map[i];
#line 168 "../src/puzzle.vala"
		if (nr != _tmp21_) {
#line 608 "puzzle.c"
			gint _tmp22_;
#line 168 "../src/puzzle.vala"
			_tmp22_ = image_map[i];
#line 168 "../src/puzzle.vala"
			_tmp20_ = _tmp22_ != -1;
#line 614 "puzzle.c"
		} else {
#line 168 "../src/puzzle.vala"
			_tmp20_ = FALSE;
#line 618 "puzzle.c"
		}
#line 168 "../src/puzzle.vala"
		if (!_tmp20_) {
#line 168 "../src/puzzle.vala"
			break;
#line 624 "puzzle.c"
		}
#line 169 "../src/puzzle.vala"
		i = i + 2;
#line 628 "puzzle.c"
	}
#line 171 "../src/puzzle.vala"
	_tmp23_ = image_map[i + 1];
#line 171 "../src/puzzle.vala"
	result = _tmp23_;
#line 171 "../src/puzzle.vala"
	return result;
#line 636 "puzzle.c"
}

gboolean
puzzle_game_over (Puzzle* self)
{
	gboolean result = FALSE;
	gboolean over = FALSE;
#line 174 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 176 "../src/puzzle.vala"
	over = TRUE;
#line 648 "puzzle.c"
	{
		gint y = 0;
#line 177 "../src/puzzle.vala"
		y = 0;
#line 653 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 177 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 177 "../src/puzzle.vala"
			while (TRUE) {
#line 177 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 662 "puzzle.c"
					gint _tmp1_;
#line 177 "../src/puzzle.vala"
					_tmp1_ = y;
#line 177 "../src/puzzle.vala"
					y = _tmp1_ + 1;
#line 668 "puzzle.c"
				}
#line 177 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 177 "../src/puzzle.vala"
				if (!(y < self->height)) {
#line 177 "../src/puzzle.vala"
					break;
#line 676 "puzzle.c"
				}
				{
					gint x = 0;
#line 178 "../src/puzzle.vala"
					x = 0;
#line 682 "puzzle.c"
					{
						gboolean _tmp2_ = FALSE;
#line 178 "../src/puzzle.vala"
						_tmp2_ = TRUE;
#line 178 "../src/puzzle.vala"
						while (TRUE) {
#line 689 "puzzle.c"
							gboolean _tmp4_ = FALSE;
							gchar* _tmp5_;
							gint _tmp5__length1;
#line 178 "../src/puzzle.vala"
							if (!_tmp2_) {
#line 695 "puzzle.c"
								gint _tmp3_;
#line 178 "../src/puzzle.vala"
								_tmp3_ = x;
#line 178 "../src/puzzle.vala"
								x = _tmp3_ + 1;
#line 701 "puzzle.c"
							}
#line 178 "../src/puzzle.vala"
							_tmp2_ = FALSE;
#line 178 "../src/puzzle.vala"
							if (!(x < self->width)) {
#line 178 "../src/puzzle.vala"
								break;
#line 709 "puzzle.c"
							}
#line 179 "../src/puzzle.vala"
							_tmp5_ = self->map;
#line 179 "../src/puzzle.vala"
							_tmp5__length1 = self->map_length1;
#line 179 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp5_, (gint) _tmp5__length1, x, y) == '*') {
#line 717 "puzzle.c"
								gchar* _tmp6_;
								gint _tmp6__length1;
#line 179 "../src/puzzle.vala"
								_tmp6_ = self->orig_map;
#line 179 "../src/puzzle.vala"
								_tmp6__length1 = self->orig_map_length1;
#line 179 "../src/puzzle.vala"
								_tmp4_ = puzzle_get_piece_id (self, _tmp6_, (gint) _tmp6__length1, x, y) != '.';
#line 726 "puzzle.c"
							} else {
#line 179 "../src/puzzle.vala"
								_tmp4_ = FALSE;
#line 730 "puzzle.c"
							}
#line 179 "../src/puzzle.vala"
							if (_tmp4_) {
#line 180 "../src/puzzle.vala"
								over = FALSE;
#line 736 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
#line 181 "../src/puzzle.vala"
	result = over;
#line 181 "../src/puzzle.vala"
	return result;
#line 748 "puzzle.c"
}

gboolean
puzzle_mapcmp (Puzzle* self,
               gchar* m1,
               gint m1_length1,
               gchar* m2,
               gint m2_length1)
{
	gboolean result = FALSE;
#line 184 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 761 "puzzle.c"
	{
		gint y = 0;
#line 186 "../src/puzzle.vala"
		y = 0;
#line 766 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 186 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 186 "../src/puzzle.vala"
			while (TRUE) {
#line 186 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 775 "puzzle.c"
					gint _tmp1_;
#line 186 "../src/puzzle.vala"
					_tmp1_ = y;
#line 186 "../src/puzzle.vala"
					y = _tmp1_ + 1;
#line 781 "puzzle.c"
				}
#line 186 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 186 "../src/puzzle.vala"
				if (!(y < self->height)) {
#line 186 "../src/puzzle.vala"
					break;
#line 789 "puzzle.c"
				}
				{
					gint x = 0;
#line 187 "../src/puzzle.vala"
					x = 0;
#line 795 "puzzle.c"
					{
						gboolean _tmp2_ = FALSE;
#line 187 "../src/puzzle.vala"
						_tmp2_ = TRUE;
#line 187 "../src/puzzle.vala"
						while (TRUE) {
#line 187 "../src/puzzle.vala"
							if (!_tmp2_) {
#line 804 "puzzle.c"
								gint _tmp3_;
#line 187 "../src/puzzle.vala"
								_tmp3_ = x;
#line 187 "../src/puzzle.vala"
								x = _tmp3_ + 1;
#line 810 "puzzle.c"
							}
#line 187 "../src/puzzle.vala"
							_tmp2_ = FALSE;
#line 187 "../src/puzzle.vala"
							if (!(x < self->width)) {
#line 187 "../src/puzzle.vala"
								break;
#line 818 "puzzle.c"
							}
#line 188 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, m1, (gint) m1_length1, x, y) != puzzle_get_piece_id (self, m2, (gint) m2_length1, x, y)) {
#line 189 "../src/puzzle.vala"
								result = TRUE;
#line 189 "../src/puzzle.vala"
								return result;
#line 826 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
#line 190 "../src/puzzle.vala"
	result = FALSE;
#line 190 "../src/puzzle.vala"
	return result;
#line 838 "puzzle.c"
}

gboolean
puzzle_movable (Puzzle* self,
                gint id)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 193 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 195 "../src/puzzle.vala"
	if (id == ((gint) '#')) {
#line 195 "../src/puzzle.vala"
		_tmp2_ = TRUE;
#line 855 "puzzle.c"
	} else {
#line 195 "../src/puzzle.vala"
		_tmp2_ = id == ((gint) '.');
#line 859 "puzzle.c"
	}
#line 195 "../src/puzzle.vala"
	if (_tmp2_) {
#line 195 "../src/puzzle.vala"
		_tmp1_ = TRUE;
#line 865 "puzzle.c"
	} else {
#line 195 "../src/puzzle.vala"
		_tmp1_ = id == ((gint) ' ');
#line 869 "puzzle.c"
	}
#line 195 "../src/puzzle.vala"
	if (_tmp1_) {
#line 195 "../src/puzzle.vala"
		_tmp0_ = TRUE;
#line 875 "puzzle.c"
	} else {
#line 195 "../src/puzzle.vala"
		_tmp0_ = id == ((gint) '-');
#line 879 "puzzle.c"
	}
#line 195 "../src/puzzle.vala"
	if (_tmp0_) {
#line 196 "../src/puzzle.vala"
		result = FALSE;
#line 196 "../src/puzzle.vala"
		return result;
#line 887 "puzzle.c"
	}
#line 197 "../src/puzzle.vala"
	result = TRUE;
#line 197 "../src/puzzle.vala"
	return result;
#line 893 "puzzle.c"
}

gboolean
puzzle_move_piece (Puzzle* self,
                   gchar id,
                   gint x1,
                   gint y1,
                   gint x2,
                   gint y2)
{
	gboolean result = FALSE;
	gboolean return_value = FALSE;
	gchar* _tmp0_;
	gint _tmp0__length1;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 200 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "../src/puzzle.vala"
	return_value = FALSE;
#line 204 "../src/puzzle.vala"
	if (!puzzle_movable (self, (gint) id)) {
#line 205 "../src/puzzle.vala"
		result = FALSE;
#line 205 "../src/puzzle.vala"
		return result;
#line 920 "puzzle.c"
	}
#line 207 "../src/puzzle.vala"
	_tmp0_ = self->map;
#line 207 "../src/puzzle.vala"
	_tmp0__length1 = self->map_length1;
#line 207 "../src/puzzle.vala"
	if (puzzle_get_piece_id (self, _tmp0_, (gint) _tmp0__length1, x2, y2) == id) {
#line 208 "../src/puzzle.vala"
		return_value = TRUE;
#line 930 "puzzle.c"
	}
#line 210 "../src/puzzle.vala"
	if (y1 == y2) {
#line 210 "../src/puzzle.vala"
		_tmp2_ = abs (x1 - x2) == 1;
#line 936 "puzzle.c"
	} else {
#line 210 "../src/puzzle.vala"
		_tmp2_ = FALSE;
#line 940 "puzzle.c"
	}
#line 210 "../src/puzzle.vala"
	if (_tmp2_) {
#line 210 "../src/puzzle.vala"
		_tmp1_ = TRUE;
#line 946 "puzzle.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 210 "../src/puzzle.vala"
		if (x1 == x2) {
#line 210 "../src/puzzle.vala"
			_tmp3_ = abs (y1 - y2) == 1;
#line 953 "puzzle.c"
		} else {
#line 210 "../src/puzzle.vala"
			_tmp3_ = FALSE;
#line 957 "puzzle.c"
		}
#line 210 "../src/puzzle.vala"
		_tmp1_ = _tmp3_;
#line 961 "puzzle.c"
	}
#line 210 "../src/puzzle.vala"
	if (!_tmp1_) {
#line 211 "../src/puzzle.vala"
		result = FALSE;
#line 211 "../src/puzzle.vala"
		return result;
#line 969 "puzzle.c"
	}
#line 213 "../src/puzzle.vala"
	if (abs (y1 - y2) == 1) {
#line 215 "../src/puzzle.vala"
		if ((y1 - y2) < 0) {
#line 216 "../src/puzzle.vala"
			if (puzzle_check_valid_move (self, (gint) id, 0, 1)) {
#line 217 "../src/puzzle.vala"
				result = puzzle_do_move_piece (self, id, 0, 1);
#line 217 "../src/puzzle.vala"
				return result;
#line 981 "puzzle.c"
			}
		}
#line 218 "../src/puzzle.vala"
		if ((y1 - y2) > 0) {
#line 219 "../src/puzzle.vala"
			if (puzzle_check_valid_move (self, (gint) id, 0, -1)) {
#line 220 "../src/puzzle.vala"
				result = puzzle_do_move_piece (self, id, 0, -1);
#line 220 "../src/puzzle.vala"
				return result;
#line 992 "puzzle.c"
			}
		}
	}
#line 223 "../src/puzzle.vala"
	if (abs (x1 - x2) == 1) {
#line 225 "../src/puzzle.vala"
		if ((x1 - x2) < 0) {
#line 226 "../src/puzzle.vala"
			if (puzzle_check_valid_move (self, (gint) id, 1, 0)) {
#line 227 "../src/puzzle.vala"
				result = puzzle_do_move_piece (self, id, 1, 0);
#line 227 "../src/puzzle.vala"
				return result;
#line 1006 "puzzle.c"
			}
		}
#line 228 "../src/puzzle.vala"
		if ((x1 - x2) > 0) {
#line 229 "../src/puzzle.vala"
			if (puzzle_check_valid_move (self, (gint) id, -1, 0)) {
#line 230 "../src/puzzle.vala"
				result = puzzle_do_move_piece (self, id, -1, 0);
#line 230 "../src/puzzle.vala"
				return result;
#line 1017 "puzzle.c"
			}
		}
	}
#line 233 "../src/puzzle.vala"
	result = return_value;
#line 233 "../src/puzzle.vala"
	return result;
#line 1025 "puzzle.c"
}

static gboolean
puzzle_check_valid_move (Puzzle* self,
                         gint id,
                         gint dx,
                         gint dy)
{
	gboolean result = FALSE;
#line 236 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1037 "puzzle.c"
	{
		gint y = 0;
#line 238 "../src/puzzle.vala"
		y = 0;
#line 1042 "puzzle.c"
		{
			gboolean _tmp0_ = FALSE;
#line 238 "../src/puzzle.vala"
			_tmp0_ = TRUE;
#line 238 "../src/puzzle.vala"
			while (TRUE) {
#line 238 "../src/puzzle.vala"
				if (!_tmp0_) {
#line 1051 "puzzle.c"
					gint _tmp1_;
#line 238 "../src/puzzle.vala"
					_tmp1_ = y;
#line 238 "../src/puzzle.vala"
					y = _tmp1_ + 1;
#line 1057 "puzzle.c"
				}
#line 238 "../src/puzzle.vala"
				_tmp0_ = FALSE;
#line 238 "../src/puzzle.vala"
				if (!(y < self->height)) {
#line 238 "../src/puzzle.vala"
					break;
#line 1065 "puzzle.c"
				}
				{
					gint x = 0;
#line 240 "../src/puzzle.vala"
					x = 0;
#line 1071 "puzzle.c"
					{
						gboolean _tmp2_ = FALSE;
#line 240 "../src/puzzle.vala"
						_tmp2_ = TRUE;
#line 240 "../src/puzzle.vala"
						while (TRUE) {
#line 1078 "puzzle.c"
							gchar* _tmp4_;
							gint _tmp4__length1;
#line 240 "../src/puzzle.vala"
							if (!_tmp2_) {
#line 1083 "puzzle.c"
								gint _tmp3_;
#line 240 "../src/puzzle.vala"
								_tmp3_ = x;
#line 240 "../src/puzzle.vala"
								x = _tmp3_ + 1;
#line 1089 "puzzle.c"
							}
#line 240 "../src/puzzle.vala"
							_tmp2_ = FALSE;
#line 240 "../src/puzzle.vala"
							if (!(x < self->width)) {
#line 240 "../src/puzzle.vala"
								break;
#line 1097 "puzzle.c"
							}
#line 242 "../src/puzzle.vala"
							_tmp4_ = self->map;
#line 242 "../src/puzzle.vala"
							_tmp4__length1 = self->map_length1;
#line 242 "../src/puzzle.vala"
							if (((gint) puzzle_get_piece_id (self, _tmp4_, (gint) _tmp4__length1, x, y)) == id) {
#line 1105 "puzzle.c"
								gchar z = '\0';
								gchar* _tmp5_;
								gint _tmp5__length1;
								gboolean _tmp6_ = FALSE;
								gboolean _tmp7_ = FALSE;
								gboolean _tmp8_ = FALSE;
#line 244 "../src/puzzle.vala"
								_tmp5_ = self->map;
#line 244 "../src/puzzle.vala"
								_tmp5__length1 = self->map_length1;
#line 244 "../src/puzzle.vala"
								z = puzzle_get_piece_id (self, _tmp5_, (gint) _tmp5__length1, x + dx, y + dy);
#line 245 "../src/puzzle.vala"
								if (z == ' ') {
#line 245 "../src/puzzle.vala"
									_tmp8_ = TRUE;
#line 1122 "puzzle.c"
								} else {
#line 245 "../src/puzzle.vala"
									_tmp8_ = z == '.';
#line 1126 "puzzle.c"
								}
#line 245 "../src/puzzle.vala"
								if (_tmp8_) {
#line 245 "../src/puzzle.vala"
									_tmp7_ = TRUE;
#line 1132 "puzzle.c"
								} else {
#line 245 "../src/puzzle.vala"
									_tmp7_ = ((gint) z) == id;
#line 1136 "puzzle.c"
								}
#line 245 "../src/puzzle.vala"
								if (_tmp7_) {
#line 245 "../src/puzzle.vala"
									_tmp6_ = TRUE;
#line 1142 "puzzle.c"
								} else {
									gboolean _tmp9_ = FALSE;
#line 245 "../src/puzzle.vala"
									if (id == ((gint) '*')) {
#line 245 "../src/puzzle.vala"
										_tmp9_ = z == '-';
#line 1149 "puzzle.c"
									} else {
#line 245 "../src/puzzle.vala"
										_tmp9_ = FALSE;
#line 1153 "puzzle.c"
									}
#line 245 "../src/puzzle.vala"
									_tmp6_ = _tmp9_;
#line 1157 "puzzle.c"
								}
#line 245 "../src/puzzle.vala"
								if (!_tmp6_) {
#line 246 "../src/puzzle.vala"
									result = FALSE;
#line 246 "../src/puzzle.vala"
									return result;
#line 1165 "puzzle.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 251 "../src/puzzle.vala"
	result = TRUE;
#line 251 "../src/puzzle.vala"
	return result;
#line 1178 "puzzle.c"
}

static gchar*
_vala_array_dup5 (gchar* self,
                  int length)
{
#line 256 "../src/puzzle.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 1187 "puzzle.c"
}

static gchar*
_vala_array_dup6 (gchar* self,
                  int length)
{
#line 290 "../src/puzzle.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 1196 "puzzle.c"
}

static gboolean
puzzle_do_move_piece (Puzzle* self,
                      gchar id,
                      gint dx,
                      gint dy)
{
	gboolean result = FALSE;
	gchar* tmpmap = NULL;
	gchar* _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gint tmpmap_length1;
	gint _tmpmap_size_;
	gchar* _tmp26_;
	gint _tmp26__length1;
	gchar* _tmp27_;
	gint _tmp27__length1;
#line 254 "../src/puzzle.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 256 "../src/puzzle.vala"
	_tmp0_ = self->map;
#line 256 "../src/puzzle.vala"
	_tmp0__length1 = self->map_length1;
#line 256 "../src/puzzle.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup5 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 256 "../src/puzzle.vala"
	_tmp1__length1 = _tmp0__length1;
#line 256 "../src/puzzle.vala"
	tmpmap = _tmp1_;
#line 256 "../src/puzzle.vala"
	tmpmap_length1 = _tmp1__length1;
#line 256 "../src/puzzle.vala"
	_tmpmap_size_ = tmpmap_length1;
#line 1233 "puzzle.c"
	{
		gint y = 0;
#line 259 "../src/puzzle.vala"
		y = 0;
#line 1238 "puzzle.c"
		{
			gboolean _tmp2_ = FALSE;
#line 259 "../src/puzzle.vala"
			_tmp2_ = TRUE;
#line 259 "../src/puzzle.vala"
			while (TRUE) {
#line 259 "../src/puzzle.vala"
				if (!_tmp2_) {
#line 1247 "puzzle.c"
					gint _tmp3_;
#line 259 "../src/puzzle.vala"
					_tmp3_ = y;
#line 259 "../src/puzzle.vala"
					y = _tmp3_ + 1;
#line 1253 "puzzle.c"
				}
#line 259 "../src/puzzle.vala"
				_tmp2_ = FALSE;
#line 259 "../src/puzzle.vala"
				if (!(y < self->height)) {
#line 259 "../src/puzzle.vala"
					break;
#line 1261 "puzzle.c"
				}
				{
					gint x = 0;
#line 260 "../src/puzzle.vala"
					x = 0;
#line 1267 "puzzle.c"
					{
						gboolean _tmp4_ = FALSE;
#line 260 "../src/puzzle.vala"
						_tmp4_ = TRUE;
#line 260 "../src/puzzle.vala"
						while (TRUE) {
#line 1274 "puzzle.c"
							gchar* _tmp6_;
							gint _tmp6__length1;
#line 260 "../src/puzzle.vala"
							if (!_tmp4_) {
#line 1279 "puzzle.c"
								gint _tmp5_;
#line 260 "../src/puzzle.vala"
								_tmp5_ = x;
#line 260 "../src/puzzle.vala"
								x = _tmp5_ + 1;
#line 1285 "puzzle.c"
							}
#line 260 "../src/puzzle.vala"
							_tmp4_ = FALSE;
#line 260 "../src/puzzle.vala"
							if (!(x < self->width)) {
#line 260 "../src/puzzle.vala"
								break;
#line 1293 "puzzle.c"
							}
#line 261 "../src/puzzle.vala"
							_tmp6_ = tmpmap;
#line 261 "../src/puzzle.vala"
							_tmp6__length1 = tmpmap_length1;
#line 261 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp6_, (gint) _tmp6__length1, x, y) == id) {
#line 1301 "puzzle.c"
								gchar* _tmp7_;
								gint _tmp7__length1;
#line 262 "../src/puzzle.vala"
								_tmp7_ = tmpmap;
#line 262 "../src/puzzle.vala"
								_tmp7__length1 = tmpmap_length1;
#line 262 "../src/puzzle.vala"
								puzzle_set_piece_id (self, _tmp7_, (gint) _tmp7__length1, x, y, ' ');
#line 1310 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
	{
		gint y = 0;
#line 264 "../src/puzzle.vala"
		y = 0;
#line 1322 "puzzle.c"
		{
			gboolean _tmp8_ = FALSE;
#line 264 "../src/puzzle.vala"
			_tmp8_ = TRUE;
#line 264 "../src/puzzle.vala"
			while (TRUE) {
#line 264 "../src/puzzle.vala"
				if (!_tmp8_) {
#line 1331 "puzzle.c"
					gint _tmp9_;
#line 264 "../src/puzzle.vala"
					_tmp9_ = y;
#line 264 "../src/puzzle.vala"
					y = _tmp9_ + 1;
#line 1337 "puzzle.c"
				}
#line 264 "../src/puzzle.vala"
				_tmp8_ = FALSE;
#line 264 "../src/puzzle.vala"
				if (!(y < self->height)) {
#line 264 "../src/puzzle.vala"
					break;
#line 1345 "puzzle.c"
				}
				{
					gint x = 0;
#line 265 "../src/puzzle.vala"
					x = 0;
#line 1351 "puzzle.c"
					{
						gboolean _tmp10_ = FALSE;
#line 265 "../src/puzzle.vala"
						_tmp10_ = TRUE;
#line 265 "../src/puzzle.vala"
						while (TRUE) {
#line 1358 "puzzle.c"
							gchar* _tmp12_;
							gint _tmp12__length1;
#line 265 "../src/puzzle.vala"
							if (!_tmp10_) {
#line 1363 "puzzle.c"
								gint _tmp11_;
#line 265 "../src/puzzle.vala"
								_tmp11_ = x;
#line 265 "../src/puzzle.vala"
								x = _tmp11_ + 1;
#line 1369 "puzzle.c"
							}
#line 265 "../src/puzzle.vala"
							_tmp10_ = FALSE;
#line 265 "../src/puzzle.vala"
							if (!(x < self->width)) {
#line 265 "../src/puzzle.vala"
								break;
#line 1377 "puzzle.c"
							}
#line 266 "../src/puzzle.vala"
							_tmp12_ = self->map;
#line 266 "../src/puzzle.vala"
							_tmp12__length1 = self->map_length1;
#line 266 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp12_, (gint) _tmp12__length1, x, y) == id) {
#line 1385 "puzzle.c"
								gchar* _tmp13_;
								gint _tmp13__length1;
#line 267 "../src/puzzle.vala"
								_tmp13_ = tmpmap;
#line 267 "../src/puzzle.vala"
								_tmp13__length1 = tmpmap_length1;
#line 267 "../src/puzzle.vala"
								puzzle_set_piece_id (self, _tmp13_, (gint) _tmp13__length1, x + dx, y + dy, id);
#line 1394 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
	{
		gint y = 0;
#line 270 "../src/puzzle.vala"
		y = 0;
#line 1406 "puzzle.c"
		{
			gboolean _tmp14_ = FALSE;
#line 270 "../src/puzzle.vala"
			_tmp14_ = TRUE;
#line 270 "../src/puzzle.vala"
			while (TRUE) {
#line 270 "../src/puzzle.vala"
				if (!_tmp14_) {
#line 1415 "puzzle.c"
					gint _tmp15_;
#line 270 "../src/puzzle.vala"
					_tmp15_ = y;
#line 270 "../src/puzzle.vala"
					y = _tmp15_ + 1;
#line 1421 "puzzle.c"
				}
#line 270 "../src/puzzle.vala"
				_tmp14_ = FALSE;
#line 270 "../src/puzzle.vala"
				if (!(y < self->height)) {
#line 270 "../src/puzzle.vala"
					break;
#line 1429 "puzzle.c"
				}
				{
					gint x = 0;
#line 272 "../src/puzzle.vala"
					x = 0;
#line 1435 "puzzle.c"
					{
						gboolean _tmp16_ = FALSE;
#line 272 "../src/puzzle.vala"
						_tmp16_ = TRUE;
#line 272 "../src/puzzle.vala"
						while (TRUE) {
#line 1442 "puzzle.c"
							gboolean _tmp18_ = FALSE;
							gchar* _tmp19_;
							gint _tmp19__length1;
							gboolean _tmp22_ = FALSE;
							gchar* _tmp23_;
							gint _tmp23__length1;
#line 272 "../src/puzzle.vala"
							if (!_tmp16_) {
#line 1451 "puzzle.c"
								gint _tmp17_;
#line 272 "../src/puzzle.vala"
								_tmp17_ = x;
#line 272 "../src/puzzle.vala"
								x = _tmp17_ + 1;
#line 1457 "puzzle.c"
							}
#line 272 "../src/puzzle.vala"
							_tmp16_ = FALSE;
#line 272 "../src/puzzle.vala"
							if (!(x < self->width)) {
#line 272 "../src/puzzle.vala"
								break;
#line 1465 "puzzle.c"
							}
#line 274 "../src/puzzle.vala"
							_tmp19_ = tmpmap;
#line 274 "../src/puzzle.vala"
							_tmp19__length1 = tmpmap_length1;
#line 274 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp19_, (gint) _tmp19__length1, x, y) == ' ') {
#line 1473 "puzzle.c"
								gchar* _tmp20_;
								gint _tmp20__length1;
#line 274 "../src/puzzle.vala"
								_tmp20_ = self->orig_map;
#line 274 "../src/puzzle.vala"
								_tmp20__length1 = self->orig_map_length1;
#line 274 "../src/puzzle.vala"
								_tmp18_ = puzzle_get_piece_id (self, _tmp20_, (gint) _tmp20__length1, x, y) == '.';
#line 1482 "puzzle.c"
							} else {
#line 274 "../src/puzzle.vala"
								_tmp18_ = FALSE;
#line 1486 "puzzle.c"
							}
#line 274 "../src/puzzle.vala"
							if (_tmp18_) {
#line 1490 "puzzle.c"
								gchar* _tmp21_;
								gint _tmp21__length1;
#line 275 "../src/puzzle.vala"
								_tmp21_ = tmpmap;
#line 275 "../src/puzzle.vala"
								_tmp21__length1 = tmpmap_length1;
#line 275 "../src/puzzle.vala"
								puzzle_set_piece_id (self, _tmp21_, (gint) _tmp21__length1, x, y, '.');
#line 1499 "puzzle.c"
							}
#line 276 "../src/puzzle.vala"
							_tmp23_ = tmpmap;
#line 276 "../src/puzzle.vala"
							_tmp23__length1 = tmpmap_length1;
#line 276 "../src/puzzle.vala"
							if (puzzle_get_piece_id (self, _tmp23_, (gint) _tmp23__length1, x, y) == ' ') {
#line 1507 "puzzle.c"
								gchar* _tmp24_;
								gint _tmp24__length1;
#line 276 "../src/puzzle.vala"
								_tmp24_ = self->orig_map;
#line 276 "../src/puzzle.vala"
								_tmp24__length1 = self->orig_map_length1;
#line 276 "../src/puzzle.vala"
								_tmp22_ = puzzle_get_piece_id (self, _tmp24_, (gint) _tmp24__length1, x, y) == '-';
#line 1516 "puzzle.c"
							} else {
#line 276 "../src/puzzle.vala"
								_tmp22_ = FALSE;
#line 1520 "puzzle.c"
							}
#line 276 "../src/puzzle.vala"
							if (_tmp22_) {
#line 1524 "puzzle.c"
								gchar* _tmp25_;
								gint _tmp25__length1;
#line 277 "../src/puzzle.vala"
								_tmp25_ = tmpmap;
#line 277 "../src/puzzle.vala"
								_tmp25__length1 = tmpmap_length1;
#line 277 "../src/puzzle.vala"
								puzzle_set_piece_id (self, _tmp25_, (gint) _tmp25__length1, x, y, '-');
#line 1533 "puzzle.c"
							}
						}
					}
				}
			}
		}
	}
#line 288 "../src/puzzle.vala"
	g_signal_emit (self, puzzle_signals[PUZZLE_CHANGED_SIGNAL], 0);
#line 290 "../src/puzzle.vala"
	_tmp26_ = tmpmap;
#line 290 "../src/puzzle.vala"
	_tmp26__length1 = tmpmap_length1;
#line 290 "../src/puzzle.vala"
	_tmp27_ = (_tmp26_ != NULL) ? _vala_array_dup6 (_tmp26_, _tmp26__length1) : ((gpointer) _tmp26_);
#line 290 "../src/puzzle.vala"
	_tmp27__length1 = _tmp26__length1;
#line 290 "../src/puzzle.vala"
	self->map = (g_free (self->map), NULL);
#line 290 "../src/puzzle.vala"
	self->map = _tmp27_;
#line 290 "../src/puzzle.vala"
	self->map_length1 = _tmp27__length1;
#line 292 "../src/puzzle.vala"
	result = TRUE;
#line 292 "../src/puzzle.vala"
	tmpmap = (g_free (tmpmap), NULL);
#line 292 "../src/puzzle.vala"
	return result;
#line 1563 "puzzle.c"
}

static void
puzzle_class_init (PuzzleClass * klass,
                   gpointer klass_data)
{
#line 87 "../src/puzzle.vala"
	puzzle_parent_class = g_type_class_peek_parent (klass);
#line 87 "../src/puzzle.vala"
	G_OBJECT_CLASS (klass)->finalize = puzzle_finalize;
#line 87 "../src/puzzle.vala"
	puzzle_signals[PUZZLE_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 87 "../src/puzzle.vala"
	puzzle_signals[PUZZLE_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1578 "puzzle.c"
}

static void
puzzle_instance_init (Puzzle * self,
                      gpointer klass)
{
#line 98 "../src/puzzle.vala"
	self->moves = 0;
#line 1587 "puzzle.c"
}

static void
puzzle_finalize (GObject * obj)
{
	Puzzle * self;
#line 87 "../src/puzzle.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE, Puzzle);
#line 92 "../src/puzzle.vala"
	self->map = (g_free (self->map), NULL);
#line 93 "../src/puzzle.vala"
	self->move_map = (g_free (self->move_map), NULL);
#line 94 "../src/puzzle.vala"
	self->orig_map = (g_free (self->orig_map), NULL);
#line 95 "../src/puzzle.vala"
	self->lastmove_map = (g_free (self->lastmove_map), NULL);
#line 96 "../src/puzzle.vala"
	self->undomove_map = (g_free (self->undomove_map), NULL);
#line 87 "../src/puzzle.vala"
	G_OBJECT_CLASS (puzzle_parent_class)->finalize (obj);
#line 1608 "puzzle.c"
}

GType
puzzle_get_type (void)
{
	static volatile gsize puzzle_type_id__volatile = 0;
	if (g_once_init_enter (&puzzle_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PuzzleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Puzzle), 0, (GInstanceInitFunc) puzzle_instance_init, NULL };
		GType puzzle_type_id;
		puzzle_type_id = g_type_register_static (G_TYPE_OBJECT, "Puzzle", &g_define_type_info, 0);
		g_once_init_leave (&puzzle_type_id__volatile, puzzle_type_id);
	}
	return puzzle_type_id__volatile;
}

